/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.0.1
 * @date    2020-10-13T17:07:07.867Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
var t="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function e(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&r.path)}},r.exports),r.exports}var r=function(t){return t&&t.Math==Math&&t},n=r("object"==typeof globalThis&&globalThis)||r("object"==typeof window&&window)||r("object"==typeof self&&self)||r("object"==typeof t&&t)||Function("return this")(),o=function(t){try{return!!t()}catch(t){return!0}},i=!o((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),a=function(t){return"object"==typeof t?null!==t:"function"==typeof t},u=n.document,c=a(u)&&a(u.createElement),s=function(t){return c?u.createElement(t):{}},f=!i&&!o((function(){return 7!=Object.defineProperty(s("div"),"a",{get:function(){return 7}}).a})),l=function(t){if(!a(t))throw TypeError(String(t)+" is not an object");return t},h=function(t,e){if(!a(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!a(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!a(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!a(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},v=Object.defineProperty,p={f:i?v:function(t,e,r){if(l(t),e=h(e,!0),l(r),f)try{return v(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},y=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},d=i?function(t,e,r){return p.f(t,e,y(1,r))}:function(t,e,r){return t[e]=r,t},g=function(t,e,r,n){n&&n.enumerable?t[e]=r:d(t,e,r)},m=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:g(t,n,e[n],r);return t},b={},w={}.hasOwnProperty,O=function(t,e){return w.call(t,e)},x=0,k=Math.random(),S=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++x+k).toString(36)},j=!o((function(){return Object.isExtensible(Object.preventExtensions({}))})),A=e((function(t){var e=p.f,r=S("meta"),n=0,o=Object.isExtensible||function(){return!0},i=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},u=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!a(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!O(t,r)){if(!o(t))return"F";if(!e)return"E";i(t)}return t[r].objectID},getWeakData:function(t,e){if(!O(t,r)){if(!o(t))return!0;if(!e)return!1;i(t)}return t[r].weakData},onFreeze:function(t){return j&&u.REQUIRED&&o(t)&&!O(t,r)&&i(t),t}};b[r]=!0})),E={}.propertyIsEnumerable,_=Object.getOwnPropertyDescriptor,I={f:_&&!E.call({1:2},1)?function(t){var e=_(this,t);return!!e&&e.enumerable}:E},T={}.toString,P=function(t){return T.call(t).slice(8,-1)},L="".split,D=o((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==P(t)?L.call(t,""):Object(t)}:Object,M=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},C=function(t){return D(M(t))},F=Object.getOwnPropertyDescriptor,R={f:i?F:function(t,e){if(t=C(t),e=h(e,!0),f)try{return F(t,e)}catch(t){}if(O(t,e))return y(!I.f.call(t,e),t[e])}},N=/#|\.prototype\./,z=function(t,e){var r=U[G(t)];return r==V||r!=q&&("function"==typeof e?o(e):!!e)},G=z.normalize=function(t){return String(t).replace(N,".").toLowerCase()},U=z.data={},q=z.NATIVE="N",V=z.POLYFILL="P",W=z,J={},$=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},B=function(t,e,r){if($(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,o){return t.call(e,r,n,o)}}return function(){return t.apply(e,arguments)}},K=R.f,Q=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},Y=function(t,e){var r,o,i,a,u,c,s,f,l=t.target,h=t.global,v=t.stat,p=t.proto,y=h?n:v?n[l]:(n[l]||{}).prototype,g=h?J:J[l]||(J[l]={}),m=g.prototype;for(i in e)r=!W(h?i:l+(v?".":"#")+i,t.forced)&&y&&O(y,i),u=g[i],r&&(c=t.noTargetGet?(f=K(y,i))&&f.value:y[i]),a=r&&c?c:e[i],r&&typeof u==typeof a||(s=t.bind&&r?B(a,n):t.wrap&&r?Q(a):p&&"function"==typeof a?B(Function.call,a):a,(t.sham||a&&a.sham||u&&u.sham)&&d(s,"sham",!0),g[i]=s,p&&(O(J,o=l+"Prototype")||d(J,o,{}),J[o][i]=a,t.real&&m&&!m[i]&&d(m,i,a)))},H=n["__core-js_shared__"]||function(t,e){try{d(n,t,e)}catch(r){n[t]=e}return e}("__core-js_shared__",{}),X=e((function(t){(t.exports=function(t,e){return H[t]||(H[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),Z=!!Object.getOwnPropertySymbols&&!o((function(){return!String(Symbol())})),tt=Z&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,et=X("wks"),rt=n.Symbol,nt=tt?rt:rt&&rt.withoutSetter||S,ot=function(t){return O(et,t)||(Z&&O(rt,t)?et[t]=rt[t]:et[t]=nt("Symbol."+t)),et[t]},it={},at=ot("iterator"),ut=Array.prototype,ct=function(t){return void 0!==t&&(it.Array===t||ut[at]===t)},st=Math.ceil,ft=Math.floor,lt=function(t){return isNaN(t=+t)?0:(t>0?ft:st)(t)},ht=Math.min,vt=function(t){return t>0?ht(lt(t),9007199254740991):0},pt={};pt[ot("toStringTag")]="z";var yt="[object z]"===String(pt),dt=ot("toStringTag"),gt="Arguments"==P(function(){return arguments}()),mt=yt?P:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),dt))?r:gt?P(e):"Object"==(n=P(e))&&"function"==typeof e.callee?"Arguments":n},bt=ot("iterator"),wt=function(t){if(null!=t)return t[bt]||t["@@iterator"]||it[mt(t)]},Ot=function(t,e,r,n){try{return n?e(l(r)[0],r[1]):e(r)}catch(e){var o=t.return;throw void 0!==o&&l(o.call(t)),e}},xt=e((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,r,n,o,i){var a,u,c,s,f,h,v,p=B(r,n,o?2:1);if(i)a=t;else{if("function"!=typeof(u=wt(t)))throw TypeError("Target is not iterable");if(ct(u)){for(c=0,s=vt(t.length);s>c;c++)if((f=o?p(l(v=t[c])[0],v[1]):p(t[c]))&&f instanceof e)return f;return new e(!1)}a=u.call(t)}for(h=a.next;!(v=h.call(a)).done;)if("object"==typeof(f=Ot(a,p,v.value,o))&&f&&f instanceof e)return f;return new e(!1)}).stop=function(t){return new e(!0,t)}})),kt=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},St=yt?{}.toString:function(){return"[object "+mt(this)+"]"},jt=p.f,At=ot("toStringTag"),Et=function(t,e,r,n){if(t){var o=r?t:t.prototype;O(o,At)||jt(o,At,{configurable:!0,value:e}),n&&!yt&&d(o,"toString",St)}},_t=function(t){return Object(M(t))},It=Array.isArray||function(t){return"Array"==P(t)},Tt=ot("species"),Pt=function(t,e){var r;return It(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!It(r.prototype)?a(r)&&null===(r=r[Tt])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)},Lt=[].push,Dt=function(t){var e=1==t,r=2==t,n=3==t,o=4==t,i=6==t,a=5==t||i;return function(u,c,s,f){for(var l,h,v=_t(u),p=D(v),y=B(c,s,3),d=vt(p.length),g=0,m=f||Pt,b=e?m(u,d):r?m(u,0):void 0;d>g;g++)if((a||g in p)&&(h=y(l=p[g],g,v),t))if(e)b[g]=h;else if(h)switch(t){case 3:return!0;case 5:return l;case 6:return g;case 2:Lt.call(b,l)}else if(o)return!1;return i?-1:n||o?o:b}},Mt={forEach:Dt(0),map:Dt(1),filter:Dt(2),some:Dt(3),every:Dt(4),find:Dt(5),findIndex:Dt(6)},Ct=Function.toString;"function"!=typeof H.inspectSource&&(H.inspectSource=function(t){return Ct.call(t)});var Ft,Rt,Nt,zt=H.inspectSource,Gt=n.WeakMap,Ut="function"==typeof Gt&&/native code/.test(zt(Gt)),qt=X("keys"),Vt=function(t){return qt[t]||(qt[t]=S(t))},Wt=n.WeakMap;if(Ut){var Jt=new Wt,$t=Jt.get,Bt=Jt.has,Kt=Jt.set;Ft=function(t,e){return Kt.call(Jt,t,e),e},Rt=function(t){return $t.call(Jt,t)||{}},Nt=function(t){return Bt.call(Jt,t)}}else{var Qt=Vt("state");b[Qt]=!0,Ft=function(t,e){return d(t,Qt,e),e},Rt=function(t){return O(t,Qt)?t[Qt]:{}},Nt=function(t){return O(t,Qt)}}var Yt={set:Ft,get:Rt,has:Nt,enforce:function(t){return Nt(t)?Rt(t):Ft(t,{})},getterFor:function(t){return function(e){var r;if(!a(e)||(r=Rt(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},Ht=p.f,Xt=Mt.forEach,Zt=Yt.set,te=Yt.getterFor,ee=function(t,e,r){var u,c=-1!==t.indexOf("Map"),s=-1!==t.indexOf("Weak"),f=c?"set":"add",l=n[t],h=l&&l.prototype,v={};if(i&&"function"==typeof l&&(s||h.forEach&&!o((function(){(new l).entries().next()})))){u=e((function(e,r){Zt(kt(e,u,t),{type:t,collection:new l}),null!=r&&xt(r,e[f],e,c)}));var p=te(t);Xt(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in h)||s&&"clear"==t||d(u.prototype,t,(function(r,n){var o=p(this).collection;if(!e&&s&&!a(r))return"get"==t&&void 0;var i=o[t](0===r?0:r,n);return e?this:i}))})),s||Ht(u.prototype,"size",{configurable:!0,get:function(){return p(this).collection.size}})}else u=r.getConstructor(e,t,c,f),A.REQUIRED=!0;return Et(u,t,!1,!0),v[t]=u,Y({global:!0,forced:!0},v),s||r.setStrong(u,t,c),u},re=A.getWeakData,ne=Yt.set,oe=Yt.getterFor,ie=Mt.find,ae=Mt.findIndex,ue=0,ce=function(t){return t.frozen||(t.frozen=new se)},se=function(){this.entries=[]},fe=function(t,e){return ie(t.entries,(function(t){return t[0]===e}))};se.prototype={get:function(t){var e=fe(this,t);if(e)return e[1]},has:function(t){return!!fe(this,t)},set:function(t,e){var r=fe(this,t);r?r[1]=e:this.entries.push([t,e])},delete:function(t){var e=ae(this.entries,(function(e){return e[0]===t}));return~e&&this.entries.splice(e,1),!!~e}};var le,he,ve,pe={getConstructor:function(t,e,r,n){var o=t((function(t,i){kt(t,o,e),ne(t,{type:e,id:ue++,frozen:void 0}),null!=i&&xt(i,t[n],t,r)})),i=oe(e),u=function(t,e,r){var n=i(t),o=re(l(e),!0);return!0===o?ce(n).set(e,r):o[n.id]=r,t};return m(o.prototype,{delete:function(t){var e=i(this);if(!a(t))return!1;var r=re(t);return!0===r?ce(e).delete(t):r&&O(r,e.id)&&delete r[e.id]},has:function(t){var e=i(this);if(!a(t))return!1;var r=re(t);return!0===r?ce(e).has(t):r&&O(r,e.id)}}),m(o.prototype,r?{get:function(t){var e=i(this);if(a(t)){var r=re(t);return!0===r?ce(e).get(t):r?r[e.id]:void 0}},set:function(t,e){return u(this,t,e)}}:{add:function(t){return u(this,t,!0)}}),o}},ye=(e((function(t){var e,r=Yt.enforce,o=!n.ActiveXObject&&"ActiveXObject"in n,i=Object.isExtensible,u=function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}},c=t.exports=ee("WeakMap",u,pe);if(Ut&&o){e=pe.getConstructor(u,"WeakMap",!0),A.REQUIRED=!0;var s=c.prototype,f=s.delete,l=s.has,h=s.get,v=s.set;m(s,{delete:function(t){if(a(t)&&!i(t)){var n=r(this);return n.frozen||(n.frozen=new e),f.call(this,t)||n.frozen.delete(t)}return f.call(this,t)},has:function(t){if(a(t)&&!i(t)){var n=r(this);return n.frozen||(n.frozen=new e),l.call(this,t)||n.frozen.has(t)}return l.call(this,t)},get:function(t){if(a(t)&&!i(t)){var n=r(this);return n.frozen||(n.frozen=new e),l.call(this,t)?h.call(this,t):n.frozen.get(t)}return h.call(this,t)},set:function(t,n){if(a(t)&&!i(t)){var o=r(this);o.frozen||(o.frozen=new e),l.call(this,t)?v.call(this,t,n):o.frozen.set(t,n)}else v.call(this,t,n);return this}})}})),!o((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype}))),de=Vt("IE_PROTO"),ge=Object.prototype,me=ye?Object.getPrototypeOf:function(t){return t=_t(t),O(t,de)?t[de]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?ge:null},be=(ot("iterator"),!1);[].keys&&("next"in(ve=[].keys())?(he=me(me(ve)))!==Object.prototype&&(le=he):be=!0),null==le&&(le={});var we,Oe={IteratorPrototype:le,BUGGY_SAFARI_ITERATORS:be},xe=Math.max,ke=Math.min,Se=function(t,e){var r=lt(t);return r<0?xe(r+e,0):ke(r,e)},je=function(t){return function(e,r,n){var o,i=C(e),a=vt(i.length),u=Se(n,a);if(t&&r!=r){for(;a>u;)if((o=i[u++])!=o)return!0}else for(;a>u;u++)if((t||u in i)&&i[u]===r)return t||u||0;return!t&&-1}},Ae={includes:je(!0),indexOf:je(!1)},Ee=Ae.indexOf,_e=function(t,e){var r,n=C(t),o=0,i=[];for(r in n)!O(b,r)&&O(n,r)&&i.push(r);for(;e.length>o;)O(n,r=e[o++])&&(~Ee(i,r)||i.push(r));return i},Ie=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Te=Object.keys||function(t){return _e(t,Ie)},Pe=i?Object.defineProperties:function(t,e){l(t);for(var r,n=Te(e),o=n.length,i=0;o>i;)p.f(t,r=n[i++],e[r]);return t},Le=function(t){return"function"==typeof t?t:void 0},De=function(t,e){return arguments.length<2?Le(J[t])||Le(n[t]):J[t]&&J[t][e]||n[t]&&n[t][e]},Me=De("document","documentElement"),Ce=Vt("IE_PROTO"),Fe=function(){},Re=function(t){return"<script>"+t+"<\/script>"},Ne=function(){try{we=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Ne=we?function(t){t.write(Re("")),t.close();var e=t.parentWindow.Object;return t=null,e}(we):((e=s("iframe")).style.display="none",Me.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(Re("document.F=Object")),t.close(),t.F);for(var r=Ie.length;r--;)delete Ne.prototype[Ie[r]];return Ne()};b[Ce]=!0;var ze=Object.create||function(t,e){var r;return null!==t?(Fe.prototype=l(t),r=new Fe,Fe.prototype=null,r[Ce]=t):r=Ne(),void 0===e?r:Pe(r,e)},Ge=Oe.IteratorPrototype,Ue=function(){return this},qe=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return l(r),function(t){if(!a(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),Ve=Oe.IteratorPrototype,We=Oe.BUGGY_SAFARI_ITERATORS,Je=ot("iterator"),$e=function(){return this},Be=function(t,e,r,n,o,i,a){!function(t,e,r){var n=e+" Iterator";t.prototype=ze(Ge,{next:y(1,r)}),Et(t,n,!1,!0),it[n]=Ue}(r,e,n);var u,c,s,f=function(t){if(t===o&&m)return m;if(!We&&t in v)return v[t];switch(t){case"keys":case"values":case"entries":return function(){return new r(this,t)}}return function(){return new r(this)}},l=e+" Iterator",h=!1,v=t.prototype,p=v[Je]||v["@@iterator"]||o&&v[o],m=!We&&p||f(o),b="Array"==e&&v.entries||p;if(b&&(u=me(b.call(new t)),Ve!==Object.prototype&&u.next&&(Et(u,l,!0,!0),it[l]=$e)),"values"==o&&p&&"values"!==p.name&&(h=!0,m=function(){return p.call(this)}),a&&v[Je]!==m&&d(v,Je,m),it[e]=m,o)if(c={values:f("values"),keys:i?m:f("keys"),entries:f("entries")},a)for(s in c)(We||h||!(s in v))&&g(v,s,c[s]);else Y({target:e,proto:!0,forced:We||h},c);return c},Ke=Yt.set,Qe=Yt.getterFor("Array Iterator");Be(Array,"Array",(function(t,e){Ke(this,{type:"Array Iterator",target:C(t),index:0,kind:e})}),(function(){var t=Qe(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");it.Arguments=it.Array;var Ye=ot("toStringTag");for(var He in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Xe=n[He],Ze=Xe&&Xe.prototype;Ze&&mt(Ze)!==Ye&&d(Ze,Ye,He),it[He]=it.Array}var tr=J.WeakMap,er=function(t,e,r,n,o,i,a,u){for(var c,s=o,f=0,l=!!a&&B(a,u,3);f<n;){if(f in r){if(c=l?l(r[f],f,e):r[f],i>0&&It(c))s=er(t,e,c,vt(c.length),s,i-1)-1;else{if(s>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[s]=c}s++}f++}return s},rr=er;Y({target:"Array",proto:!0},{flatMap:function(t){var e,r=_t(this),n=vt(r.length);return $(t),(e=Pt(r,0)).length=rr(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var nr,or,ir=function(t){return J[t+"Prototype"]},ar=ir("Array").flatMap,ur=Array.prototype,cr=function(t){var e=t.flatMap;return t===ur||t instanceof Array&&e===ur.flatMap?ar:e},sr=De("navigator","userAgent")||"",fr=n.process,lr=fr&&fr.versions,hr=lr&&lr.v8;hr?or=(nr=hr.split("."))[0]+nr[1]:sr&&(!(nr=sr.match(/Edge\/(\d+)/))||nr[1]>=74)&&(nr=sr.match(/Chrome\/(\d+)/))&&(or=nr[1]);var vr=or&&+or,pr=ot("species"),yr=function(t){return vr>=51||!o((function(){var e=[];return(e.constructor={})[pr]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},dr=Object.defineProperty,gr={},mr=function(t){throw t},br=function(t,e){if(O(gr,t))return gr[t];e||(e={});var r=[][t],n=!!O(e,"ACCESSORS")&&e.ACCESSORS,a=O(e,0)?e[0]:mr,u=O(e,1)?e[1]:void 0;return gr[t]=!!r&&!o((function(){if(n&&!i)return!0;var t={length:-1};n?dr(t,1,{enumerable:!0,get:mr}):t[1]=1,r.call(t,a,u)}))},wr=Mt.map,Or=yr("map"),xr=br("map");Y({target:"Array",proto:!0,forced:!Or||!xr},{map:function(t){return wr(this,t,arguments.length>1?arguments[1]:void 0)}});var kr=ir("Array").map,Sr=Array.prototype,jr=function(t){var e=t.map;return t===Sr||t instanceof Array&&e===Sr.map?kr:e},Ar=Mt.filter,Er=yr("filter"),_r=br("filter");Y({target:"Array",proto:!0,forced:!Er||!_r},{filter:function(t){return Ar(this,t,arguments.length>1?arguments[1]:void 0)}});var Ir=ir("Array").filter,Tr=Array.prototype,Pr=function(t){var e=t.filter;return t===Tr||t instanceof Array&&e===Tr.filter?Ir:e},Lr=function(t){return function(e,r,n,o){$(r);var i=_t(e),a=D(i),u=vt(i.length),c=t?u-1:0,s=t?-1:1;if(n<2)for(;;){if(c in a){o=a[c],c+=s;break}if(c+=s,t?c<0:u<=c)throw TypeError("Reduce of empty array with no initial value")}for(;t?c>=0:u>c;c+=s)c in a&&(o=r(o,a[c],c,i));return o}},Dr=function(t,e){var r=[][t];return!!r&&o((function(){r.call(null,e||function(){throw 1},1)}))},Mr={left:Lr(!1),right:Lr(!0)}.left,Cr=Dr("reduce"),Fr=br("reduce",{1:0});Y({target:"Array",proto:!0,forced:!Cr||!Fr},{reduce:function(t){return Mr(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Rr=ir("Array").reduce,Nr=Array.prototype,zr=function(t){var e=t.reduce;return t===Nr||t instanceof Array&&e===Nr.reduce?Rr:e},Gr=[].slice,Ur={},qr=function(t,e,r){if(!(e in Ur)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";Ur[e]=Function("C,a","return new C("+n.join(",")+")")}return Ur[e](t,r)},Vr=Function.bind||function(t){var e=$(this),r=Gr.call(arguments,1),n=function(){var o=r.concat(Gr.call(arguments));return this instanceof n?qr(e,o.length,o):e.apply(t,o)};return a(e.prototype)&&(n.prototype=e.prototype),n};Y({target:"Function",proto:!0},{bind:Vr});var Wr=ir("Function").bind,Jr=Function.prototype,$r=function(t){var e=t.bind;return t===Jr||t instanceof Function&&e===Jr.bind?Wr:e};var Br=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};Y({target:"Object",stat:!0,forced:!i,sham:!i},{defineProperty:p.f});var Kr=e((function(t){var e=J.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),Qr=Kr;function Yr(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Qr(t,n.key,n)}}var Hr,Xr=function(t,e,r){return e&&Yr(t.prototype,e),r&&Yr(t,r),t};
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */function Zr(t,e){if(!e.has(t))throw new TypeError("attempted to get private field on non-instance");return e.get(t)}function tn(t,e,r){if(!e.has(t))throw new TypeError("attempted to set private field on non-instance");return e.set(t,r),r}function en(t){return new nn(t)}var rn=function(){function t(e,r,n){var o,i,a;Br(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:$r(o=this._add).call(o,this),remove:$r(i=this._remove).call(i,this),update:$r(a=this._update).call(a,this)}}return Xr(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return zr(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),nn=function(){function t(e){Br(this,t),this._source=e,Hr.set(this,[])}return Xr(t,[{key:"filter",value:function(t){return Zr(this,Hr).push((function(e){return Pr(e).call(e,t)})),this}},{key:"map",value:function(t){return Zr(this,Hr).push((function(e){return jr(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return Zr(this,Hr).push((function(e){return cr(e).call(e,t)})),this}},{key:"to",value:function(t){return new rn(this._source,Zr(this,Hr),t)}}]),t}();Hr=new tr;var on=Kr;Y({target:"Object",stat:!0,forced:!i,sham:!i},{defineProperties:Pe});var an=e((function(t){var e=J.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),un=Ie.concat("length","prototype"),cn={f:Object.getOwnPropertyNames||function(t){return _e(t,un)}},sn={f:Object.getOwnPropertySymbols},fn=De("Reflect","ownKeys")||function(t){var e=cn.f(l(t)),r=sn.f;return r?e.concat(r(t)):e},ln=function(t,e,r){var n=h(e);n in t?p.f(t,n,y(0,r)):t[n]=r};Y({target:"Object",stat:!0,sham:!i},{getOwnPropertyDescriptors:function(t){for(var e,r,n=C(t),o=R.f,i=fn(n),a={},u=0;i.length>u;)void 0!==(r=o(n,e=i[u++]))&&ln(a,e,r);return a}});var hn=J.Object.getOwnPropertyDescriptors,vn=Mt.forEach,pn=Dr("forEach"),yn=br("forEach"),dn=pn&&yn?[].forEach:function(t){return vn(this,t,arguments.length>1?arguments[1]:void 0)};Y({target:"Array",proto:!0,forced:[].forEach!=dn},{forEach:dn});var gn=ir("Array").forEach,mn=Array.prototype,bn={DOMTokenList:!0,NodeList:!0},wn=function(t){var e=t.forEach;return t===mn||t instanceof Array&&e===mn.forEach||bn.hasOwnProperty(mt(t))?gn:e},On=R.f,xn=o((function(){On(1)}));Y({target:"Object",stat:!0,forced:!i||xn,sham:!i},{getOwnPropertyDescriptor:function(t,e){return On(C(t),e)}});var kn=e((function(t){var e=J.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),Sn=cn.f,jn={}.toString,An="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],En={f:function(t){return An&&"[object Window]"==jn.call(t)?function(t){try{return Sn(t)}catch(t){return An.slice()}}(t):Sn(C(t))}},_n={f:ot},In=p.f,Tn=function(t){var e=J.Symbol||(J.Symbol={});O(e,t)||In(e,t,{value:_n.f(t)})},Pn=Mt.forEach,Ln=Vt("hidden"),Dn=ot("toPrimitive"),Mn=Yt.set,Cn=Yt.getterFor("Symbol"),Fn=Object.prototype,Rn=n.Symbol,Nn=De("JSON","stringify"),zn=R.f,Gn=p.f,Un=En.f,qn=I.f,Vn=X("symbols"),Wn=X("op-symbols"),Jn=X("string-to-symbol-registry"),$n=X("symbol-to-string-registry"),Bn=X("wks"),Kn=n.QObject,Qn=!Kn||!Kn.prototype||!Kn.prototype.findChild,Yn=i&&o((function(){return 7!=ze(Gn({},"a",{get:function(){return Gn(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=zn(Fn,e);n&&delete Fn[e],Gn(t,e,r),n&&t!==Fn&&Gn(Fn,e,n)}:Gn,Hn=function(t,e){var r=Vn[t]=ze(Rn.prototype);return Mn(r,{type:"Symbol",tag:t,description:e}),i||(r.description=e),r},Xn=tt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Rn},Zn=function(t,e,r){t===Fn&&Zn(Wn,e,r),l(t);var n=h(e,!0);return l(r),O(Vn,n)?(r.enumerable?(O(t,Ln)&&t[Ln][n]&&(t[Ln][n]=!1),r=ze(r,{enumerable:y(0,!1)})):(O(t,Ln)||Gn(t,Ln,y(1,{})),t[Ln][n]=!0),Yn(t,n,r)):Gn(t,n,r)},to=function(t,e){l(t);var r=C(e),n=Te(r).concat(oo(r));return Pn(n,(function(e){i&&!eo.call(r,e)||Zn(t,e,r[e])})),t},eo=function(t){var e=h(t,!0),r=qn.call(this,e);return!(this===Fn&&O(Vn,e)&&!O(Wn,e))&&(!(r||!O(this,e)||!O(Vn,e)||O(this,Ln)&&this[Ln][e])||r)},ro=function(t,e){var r=C(t),n=h(e,!0);if(r!==Fn||!O(Vn,n)||O(Wn,n)){var o=zn(r,n);return!o||!O(Vn,n)||O(r,Ln)&&r[Ln][n]||(o.enumerable=!0),o}},no=function(t){var e=Un(C(t)),r=[];return Pn(e,(function(t){O(Vn,t)||O(b,t)||r.push(t)})),r},oo=function(t){var e=t===Fn,r=Un(e?Wn:C(t)),n=[];return Pn(r,(function(t){!O(Vn,t)||e&&!O(Fn,t)||n.push(Vn[t])})),n};if(Z||(g((Rn=function(){if(this instanceof Rn)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=S(t),r=function(t){this===Fn&&r.call(Wn,t),O(this,Ln)&&O(this[Ln],e)&&(this[Ln][e]=!1),Yn(this,e,y(1,t))};return i&&Qn&&Yn(Fn,e,{configurable:!0,set:r}),Hn(e,t)}).prototype,"toString",(function(){return Cn(this).tag})),g(Rn,"withoutSetter",(function(t){return Hn(S(t),t)})),I.f=eo,p.f=Zn,R.f=ro,cn.f=En.f=no,sn.f=oo,_n.f=function(t){return Hn(ot(t),t)},i&&Gn(Rn.prototype,"description",{configurable:!0,get:function(){return Cn(this).description}})),Y({global:!0,wrap:!0,forced:!Z,sham:!Z},{Symbol:Rn}),Pn(Te(Bn),(function(t){Tn(t)})),Y({target:"Symbol",stat:!0,forced:!Z},{for:function(t){var e=String(t);if(O(Jn,e))return Jn[e];var r=Rn(e);return Jn[e]=r,$n[r]=e,r},keyFor:function(t){if(!Xn(t))throw TypeError(t+" is not a symbol");if(O($n,t))return $n[t]},useSetter:function(){Qn=!0},useSimple:function(){Qn=!1}}),Y({target:"Object",stat:!0,forced:!Z,sham:!i},{create:function(t,e){return void 0===e?ze(t):to(ze(t),e)},defineProperty:Zn,defineProperties:to,getOwnPropertyDescriptor:ro}),Y({target:"Object",stat:!0,forced:!Z},{getOwnPropertyNames:no,getOwnPropertySymbols:oo}),Y({target:"Object",stat:!0,forced:o((function(){sn.f(1)}))},{getOwnPropertySymbols:function(t){return sn.f(_t(t))}}),Nn){var io=!Z||o((function(){var t=Rn();return"[null]"!=Nn([t])||"{}"!=Nn({a:t})||"{}"!=Nn(Object(t))}));Y({target:"JSON",stat:!0,forced:io},{stringify:function(t,e,r){for(var n,o=[t],i=1;arguments.length>i;)o.push(arguments[i++]);if(n=e,(a(e)||void 0!==t)&&!Xn(t))return It(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Xn(e))return e}),o[1]=e,Nn.apply(null,o)}})}Rn.prototype[Dn]||d(Rn.prototype,Dn,Rn.prototype.valueOf),Et(Rn,"Symbol"),b[Ln]=!0;var ao=J.Object.getOwnPropertySymbols,uo=function(t){return function(e,r){var n,o,i=String(M(e)),a=lt(r),u=i.length;return a<0||a>=u?t?"":void 0:(n=i.charCodeAt(a))<55296||n>56319||a+1===u||(o=i.charCodeAt(a+1))<56320||o>57343?t?i.charAt(a):n:t?i.slice(a,a+2):o-56320+(n-55296<<10)+65536}},co={codeAt:uo(!1),charAt:uo(!0)}.charAt,so=Yt.set,fo=Yt.getterFor("String Iterator");Be(String,"String",(function(t){so(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=fo(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=co(r,n),e.index+=t.length,{value:t,done:!1})}));var lo=function(t){var e=wt(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return l(e.call(t))},ho=wt,vo=ot("isConcatSpreadable"),po=vr>=51||!o((function(){var t=[];return t[vo]=!1,t.concat()[0]!==t})),yo=yr("concat"),go=function(t){if(!a(t))return!1;var e=t[vo];return void 0!==e?!!e:It(t)};Y({target:"Array",proto:!0,forced:!po||!yo},{concat:function(t){var e,r,n,o,i,a=_t(this),u=Pt(a,0),c=0;for(e=-1,n=arguments.length;e<n;e++)if(go(i=-1===e?a:arguments[e])){if(c+(o=vt(i.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(r=0;r<o;r++,c++)r in i&&ln(u,c,i[r])}else{if(c>=9007199254740991)throw TypeError("Maximum allowed index exceeded");ln(u,c++,i)}return u.length=c,u}}),Tn("asyncIterator"),Tn("hasInstance"),Tn("isConcatSpreadable"),Tn("iterator"),Tn("match"),Tn("matchAll"),Tn("replace"),Tn("search"),Tn("species"),Tn("split"),Tn("toPrimitive"),Tn("toStringTag"),Tn("unscopables"),Et(Math,"Math",!0),Et(n.JSON,"JSON",!0);var mo=J.Symbol,bo=mo,wo=ot("iterator"),Oo=!1;try{var xo=0,ko={next:function(){return{done:!!xo++}},return:function(){Oo=!0}};ko[wo]=function(){return this},Array.from(ko,(function(){throw 2}))}catch(t){}var So=!function(t,e){if(!e&&!Oo)return!1;var r=!1;try{var n={};n[wo]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));Y({target:"Array",stat:!0,forced:So},{from:function(t){var e,r,n,o,i,a,u=_t(t),c="function"==typeof this?this:Array,s=arguments.length,f=s>1?arguments[1]:void 0,l=void 0!==f,h=wt(u),v=0;if(l&&(f=B(f,s>2?arguments[2]:void 0,2)),null==h||c==Array&&ct(h))for(r=new c(e=vt(u.length));e>v;v++)a=l?f(u[v],v):u[v],ln(r,v,a);else for(i=(o=h.call(u)).next,r=new c;!(n=i.call(o)).done;v++)a=l?Ot(o,f,[n.value,v],!0):n.value,ln(r,v,a);return r.length=v,r}});var jo=J.Array.from,Ao=jo,Eo=yr("slice"),_o=br("slice",{ACCESSORS:!0,0:0,1:2}),Io=ot("species"),To=[].slice,Po=Math.max;Y({target:"Array",proto:!0,forced:!Eo||!_o},{slice:function(t,e){var r,n,o,i=C(this),u=vt(i.length),c=Se(t,u),s=Se(void 0===e?u:e,u);if(It(i)&&("function"!=typeof(r=i.constructor)||r!==Array&&!It(r.prototype)?a(r)&&null===(r=r[Io])&&(r=void 0):r=void 0,r===Array||void 0===r))return To.call(i,c,s);for(n=new(void 0===r?Array:r)(Po(s-c,0)),o=0;c<s;c++,o++)c in i&&ln(n,o,i[c]);return n.length=o,n}});var Lo=ir("Array").slice,Do=Array.prototype,Mo=function(t){var e=t.slice;return t===Do||t instanceof Array&&e===Do.slice?Lo:e},Co=Mo,Fo=De("Reflect","construct"),Ro=o((function(){function t(){}return!(Fo((function(){}),[],t)instanceof t)})),No=!o((function(){Fo((function(){}))})),zo=Ro||No;Y({target:"Reflect",stat:!0,forced:zo,sham:zo},{construct:function(t,e){$(t),l(e);var r=arguments.length<3?t:$(arguments[2]);if(No&&!Ro)return Fo(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(Vr.apply(t,n))}var o=r.prototype,i=ze(a(o)?o:Object.prototype),u=Function.apply.call(t,i,e);return a(u)?u:i}});var Go=J.Reflect.construct,Uo=ir("Array").entries,qo=Array.prototype,Vo={DOMTokenList:!0,NodeList:!0},Wo=function(t){var e=t.entries;return t===qo||t instanceof Array&&e===qo.entries||Vo.hasOwnProperty(mt(t))?Uo:e},Jo=e((function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,o="function"==typeof Symbol?Symbol:{},i=o.iterator||"@@iterator",a=o.asyncIterator||"@@asyncIterator",u=o.toStringTag||"@@toStringTag";function c(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{c({},"")}catch(t){c=function(t,e,r){return t[e]=r}}function s(t,e,r,n){var o=e&&e.prototype instanceof d?e:d,i=Object.create(o.prototype),a=new _(n||[]);return i._invoke=function(t,e,r){var n=l;return function(o,i){if(n===v)throw new Error("Generator is already running");if(n===p){if("throw"===o)throw i;return T()}for(r.method=o,r.arg=i;;){var a=r.delegate;if(a){var u=j(a,r);if(u){if(u===y)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===l)throw n=p,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=v;var c=f(t,e,r);if("normal"===c.type){if(n=r.done?p:h,c.arg===y)continue;return{value:c.arg,done:r.done}}"throw"===c.type&&(n=p,r.method="throw",r.arg=c.arg)}}}(t,r,a),i}function f(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=s;var l="suspendedStart",h="suspendedYield",v="executing",p="completed",y={};function d(){}function g(){}function m(){}var b={};b[i]=function(){return this};var w=Object.getPrototypeOf,O=w&&w(w(I([])));O&&O!==r&&n.call(O,i)&&(b=O);var x=m.prototype=d.prototype=Object.create(b);function k(t){["next","throw","return"].forEach((function(e){c(t,e,(function(t){return this._invoke(e,t)}))}))}function S(t,e){function r(o,i,a,u){var c=f(t[o],t,i);if("throw"!==c.type){var s=c.arg,l=s.value;return l&&"object"==typeof l&&n.call(l,"__await")?e.resolve(l.__await).then((function(t){r("next",t,a,u)}),(function(t){r("throw",t,a,u)})):e.resolve(l).then((function(t){s.value=t,a(s)}),(function(t){return r("throw",t,a,u)}))}u(c.arg)}var o;this._invoke=function(t,n){function i(){return new e((function(e,o){r(t,n,e,o)}))}return o=o?o.then(i,i):i()}}function j(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,j(t,r),"throw"===r.method))return y;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return y}var o=f(n,t.iterator,r.arg);if("throw"===o.type)return r.method="throw",r.arg=o.arg,r.delegate=null,y;var i=o.arg;return i?i.done?(r[t.resultName]=i.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,y):i:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,y)}function A(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function E(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function _(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(A,this),this.reset(!0)}function I(t){if(t){var r=t[i];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var o=-1,a=function r(){for(;++o<t.length;)if(n.call(t,o))return r.value=t[o],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:T}}function T(){return{value:e,done:!0}}return g.prototype=x.constructor=m,m.constructor=g,g.displayName=c(m,u,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===g||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,c(t,u,"GeneratorFunction")),t.prototype=Object.create(x),t},t.awrap=function(t){return{__await:t}},k(S.prototype),S.prototype[a]=function(){return this},t.AsyncIterator=S,t.async=function(e,r,n,o,i){void 0===i&&(i=Promise);var a=new S(s(e,r,n,o),i);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},k(x),c(x,u,"Generator"),x[i]=function(){return this},x.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=I,_.prototype={constructor:_,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(E),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function o(n,o){return u.type="throw",u.arg=t,r.next=n,o&&(r.method="next",r.arg=e),!!o}for(var i=this.tryEntries.length-1;i>=0;--i){var a=this.tryEntries[i],u=a.completion;if("root"===a.tryLoc)return o("end");if(a.tryLoc<=this.prev){var c=n.call(a,"catchLoc"),s=n.call(a,"finallyLoc");if(c&&s){if(this.prev<a.catchLoc)return o(a.catchLoc,!0);if(this.prev<a.finallyLoc)return o(a.finallyLoc)}else if(c){if(this.prev<a.catchLoc)return o(a.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return o(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var o=this.tryEntries[r];if(o.tryLoc<=this.prev&&n.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var i=o;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var a=i?i.completion:{};return a.type=t,a.arg=e,i?(this.method="next",this.next=i.finallyLoc,y):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),y},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),E(r),y}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;E(r)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:I(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),y}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),$o=_n.f("iterator"),Bo=$o;var Ko=function(t,e,r){return e in t?Qr(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},Qo=De("JSON","stringify"),Yo=/[\uD800-\uDFFF]/g,Ho=/^[\uD800-\uDBFF]$/,Xo=/^[\uDC00-\uDFFF]$/,Zo=function(t,e,r){var n=r.charAt(e-1),o=r.charAt(e+1);return Ho.test(t)&&!Xo.test(o)||Xo.test(t)&&!Ho.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},ti=o((function(){return'"\\udf06\\ud834"'!==Qo("\udf06\ud834")||'"\\udead"'!==Qo("\udead")}));Qo&&Y({target:"JSON",stat:!0,forced:ti},{stringify:function(t,e,r){var n=Qo.apply(null,arguments);return"string"==typeof n?n.replace(Yo,Zo):n}}),J.JSON||(J.JSON={stringify:JSON.stringify});var ei=function(t,e,r){return J.JSON.stringify.apply(null,arguments)},ri=ir("Array").values,ni=Array.prototype,oi={DOMTokenList:!0,NodeList:!0},ii=function(t){var e=t.values;return t===ni||t instanceof Array&&e===ni.values||oi.hasOwnProperty(mt(t))?ri:e},ai=[],ui=ai.sort,ci=o((function(){ai.sort(void 0)})),si=o((function(){ai.sort(null)})),fi=Dr("sort");Y({target:"Array",proto:!0,forced:ci||!si||!fi},{sort:function(t){return void 0===t?ui.call(_t(this)):ui.call(_t(this),$(t))}});var li=ir("Array").sort,hi=Array.prototype,vi=function(t){var e=t.sort;return t===hi||t instanceof Array&&e===hi.sort?li:e},pi=o((function(){Te(1)}));Y({target:"Object",stat:!0,forced:pi},{keys:function(t){return Te(_t(t))}});var yi=J.Object.keys,di=ir("Array").keys,gi=Array.prototype,mi={DOMTokenList:!0,NodeList:!0},bi=function(t){var e=t.keys;return t===gi||t instanceof Array&&e===gi.keys||mi.hasOwnProperty(mt(t))?di:e};Y({target:"Array",stat:!0},{isArray:It});var wi=J.Array.isArray,Oi=wi;var xi=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var ki=function(t){if(Oi(t))return xi(t)},Si=jo,ji=ot("iterator"),Ai=function(t){var e=Object(t);return void 0!==e[ji]||"@@iterator"in e||it.hasOwnProperty(mt(e))};Tn("asyncDispose"),Tn("dispose"),Tn("observable"),Tn("patternMatch"),Tn("replaceAll");var Ei=mo;var _i=function(t){if(void 0!==Ei&&Ai(Object(t)))return Si(t)},Ii=Mo;var Ti=function(t,e){var r;if(t){if("string"==typeof t)return xi(t,e);var n=Ii(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Si(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?xi(t,e):void 0}};var Pi=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Li=function(t){return ki(t)||_i(t)||Ti(t)||Pi()},Di=ir("Array").concat,Mi=Array.prototype,Ci=function(t){var e=t.concat;return t===Mi||t instanceof Array&&e===Mi.concat?Di:e},Fi=Object.assign,Ri=Object.defineProperty,Ni=!Fi||o((function(){if(i&&1!==Fi({b:1},Fi(Ri({},"a",{enumerable:!0,get:function(){Ri(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Fi({},t)[r]||Te(Fi({},e)).join("")!=n}))?function(t,e){for(var r=_t(t),n=arguments.length,o=1,a=sn.f,u=I.f;n>o;)for(var c,s=D(arguments[o++]),f=a?Te(s).concat(a(s)):Te(s),l=f.length,h=0;l>h;)c=f[h++],i&&!u.call(s,c)||(r[c]=s[c]);return r}:Fi;Y({target:"Object",stat:!0,forced:Object.assign!==Ni},{assign:Ni});var zi=J.Object.assign,Gi=Mt.some,Ui=Dr("some"),qi=br("some");Y({target:"Array",proto:!0,forced:!Ui||!qi},{some:function(t){return Gi(this,t,arguments.length>1?arguments[1]:void 0)}});var Vi=ir("Array").some,Wi=Array.prototype,Ji=function(t){var e=t.some;return t===Wi||t instanceof Array&&e===Wi.some?Vi:e},$i=$o,Bi=e((function(t){function e(r){return t.exports=e="function"==typeof Ei&&"symbol"==typeof $i?function(t){return typeof t}:function(t){return t&&"function"==typeof Ei&&t.constructor===Ei&&t!==Ei.prototype?"symbol":typeof t},e(r)}t.exports=e})),Ki=ot("species"),Qi=p.f,Yi=A.fastKey,Hi=Yt.set,Xi=Yt.getterFor,Zi={getConstructor:function(t,e,r,n){var o=t((function(t,a){kt(t,o,e),Hi(t,{type:e,index:ze(null),first:void 0,last:void 0,size:0}),i||(t.size=0),null!=a&&xt(a,t[n],t,r)})),a=Xi(e),u=function(t,e,r){var n,o,u=a(t),s=c(t,e);return s?s.value=r:(u.last=s={index:o=Yi(e,!0),key:e,value:r,previous:n=u.last,next:void 0,removed:!1},u.first||(u.first=s),n&&(n.next=s),i?u.size++:t.size++,"F"!==o&&(u.index[o]=s)),t},c=function(t,e){var r,n=a(t),o=Yi(e);if("F"!==o)return n.index[o];for(r=n.first;r;r=r.next)if(r.key==e)return r};return m(o.prototype,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,i?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=c(e,t);if(n){var o=n.next,u=n.previous;delete r.index[n.index],n.removed=!0,u&&(u.next=o),o&&(o.previous=u),r.first==n&&(r.first=o),r.last==n&&(r.last=u),i?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=B(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!c(this,t)}}),m(o.prototype,r?{get:function(t){var e=c(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),i&&Qi(o.prototype,"size",{get:function(){return a(this).size}}),o},setStrong:function(t,e,r){var n=e+" Iterator",o=Xi(e),a=Xi(n);Be(t,e,(function(t,e){Hi(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=a(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=De(t),r=p.f;i&&e&&!e[Ki]&&r(e,Ki,{configurable:!0,get:function(){return this}})}(e)}},ta=(ee("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Zi),J.Map),ea=wi;var ra=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};Y({target:"Object",stat:!0,sham:!i},{create:ze});var na=J.Object,oa=function(t,e){return na.create(t,e)},ia=oa;Y({target:"Object",stat:!0},{setPrototypeOf:qe});var aa=J.Object.setPrototypeOf,ua=e((function(t){function e(r,n){return t.exports=e=aa||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var ca=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=ia(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&ua(t,e)};var sa=function(t,e){return!e||"object"!==Bi(e)&&"function"!=typeof e?ra(t):e},fa=o((function(){me(1)}));Y({target:"Object",stat:!0,forced:fa,sham:!ye},{getPrototypeOf:function(t){return me(_t(t))}});var la=J.Object.getPrototypeOf,ha=e((function(t){function e(r){return t.exports=e=aa?la:function(t){return t.__proto__||la(t)},e(r)}t.exports=e})),va="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),pa=new Uint8Array(16);function ya(){if(!va)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return va(pa)}var da=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function ga(t){return"string"==typeof t&&da.test(t)}for(var ma=[],ba=0;ba<256;++ba)ma.push((ba+256).toString(16).substr(1));function wa(t,e,r){var n=(t=t||{}).random||(t.rng||ya)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var o=0;o<16;++o)e[r+o]=n[o];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(ma[t[e+0]]+ma[t[e+1]]+ma[t[e+2]]+ma[t[e+3]]+"-"+ma[t[e+4]]+ma[t[e+5]]+"-"+ma[t[e+6]]+ma[t[e+7]]+"-"+ma[t[e+8]]+ma[t[e+9]]+"-"+ma[t[e+10]]+ma[t[e+11]]+ma[t[e+12]]+ma[t[e+13]]+ma[t[e+14]]+ma[t[e+15]]).toLowerCase();if(!ga(r))throw TypeError("Stringified UUID is invalid");return r}(n)}var Oa,xa=oa,ka="\t\n\v\f\r                　\u2028\u2029\ufeff",Sa="["+ka+"]",ja=RegExp("^"+Sa+Sa+"*"),Aa=RegExp(Sa+Sa+"*$"),Ea=function(t){return function(e){var r=String(M(e));return 1&t&&(r=r.replace(ja,"")),2&t&&(r=r.replace(Aa,"")),r}},_a={start:Ea(1),end:Ea(2),trim:Ea(3)},Ia=_a.trim;Y({target:"String",proto:!0,forced:(Oa="trim",o((function(){return!!ka[Oa]()||"​᠎"!="​᠎"[Oa]()||ka[Oa].name!==Oa})))},{trim:function(){return Ia(this)}});ir("String").trim;var Ta=_a.trim,Pa=n.parseInt,La=/^[+-]?0[Xx]/,Da=8!==Pa(ka+"08")||22!==Pa(ka+"0x16")?function(t,e){var r=Ta(String(t));return Pa(r,e>>>0||(La.test(r)?16:10))}:Pa;Y({global:!0,forced:parseInt!=Da},{parseInt:Da});var Ma=I.f,Ca=function(t){return function(e){for(var r,n=C(e),o=Te(n),a=o.length,u=0,c=[];a>u;)r=o[u++],i&&!Ma.call(n,r)||c.push(t?[r,n[r]]:n[r]);return c}},Fa={entries:Ca(!0),values:Ca(!1)}.values;Y({target:"Object",stat:!0},{values:function(t){return Fa(t)}});J.Object.values;var Ra=Ae.indexOf,Na=[].indexOf,za=!!Na&&1/[1].indexOf(1,-0)<0,Ga=Dr("indexOf"),Ua=br("indexOf",{ACCESSORS:!0,1:0});Y({target:"Array",proto:!0,forced:za||!Ga||!Ua},{indexOf:function(t){return za?Na.apply(this,arguments)||0:Ra(this,t,arguments.length>1?arguments[1]:void 0)}});ir("Array").indexOf;var qa=function(t){if(Oi(t))return t};var Va=function(t,e){if(void 0!==Ei&&Ai(Object(t))){var r=[],n=!0,o=!1,i=void 0;try{for(var a,u=lo(t);!(n=(a=u.next()).done)&&(r.push(a.value),!e||r.length!==e);n=!0);}catch(t){o=!0,i=t}finally{try{n||null==u.return||u.return()}finally{if(o)throw i}}return r}};var Wa=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Ja=function(t,e){return qa(t)||Va(t,e)||Ti(t,e)||Wa()};Y({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});J.Date.now;Y({target:"Reflect",stat:!0},{ownKeys:fn});var $a=J.Reflect.ownKeys;function Ba(t,e){var r;if(void 0===bo||null==ho(t)){if(ea(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Ka(t,e);var n=Co(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ao(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ka(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=lo(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Ka(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}
/**
 * vis-util
 * https://github.com/visjs/vis-util
 *
 * utilitie collection for visjs
 *
 * @version 4.3.4
 * @date    2020-08-01T15:11:53.524Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */var Qa=bo("DELETE");function Ya(){var t=Ha.apply(void 0,arguments);return Za(t),t}function Ha(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Ha.apply(void 0,Ci(n=[Ya(e[0],e[1])]).call(n,Li(Co(e).call(e,2))));var o,i=e[0],a=e[1],u=Ba($a(a));try{for(u.s();!(o=u.n()).done;){var c=o.value;Object.prototype.propertyIsEnumerable.call(a,c)&&(a[c]===Qa?delete i[c]:null===i[c]||null===a[c]||"object"!==Bi(i[c])||"object"!==Bi(a[c])||ea(i[c])||ea(a[c])?i[c]=Xa(a[c]):i[c]=Ha(i[c],a[c]))}}catch(t){u.e(t)}finally{u.f()}return i}function Xa(t){return ea(t)?jr(t).call(t,(function(t){return Xa(t)})):"object"===Bi(t)&&null!==t?Ha({},t):t}function Za(t){for(var e=0,r=yi(t);e<r.length;e++){var n=r[e];t[n]===Qa?delete t[n]:"object"===Bi(t[n])&&null!==t[n]&&Za(t[n])}}function tu(t){return"string"==typeof t||"number"==typeof t}var eu=yr("splice"),ru=br("splice",{ACCESSORS:!0,0:0,1:2}),nu=Math.max,ou=Math.min;Y({target:"Array",proto:!0,forced:!eu||!ru},{splice:function(t,e){var r,n,o,i,a,u,c=_t(this),s=vt(c.length),f=Se(t,s),l=arguments.length;if(0===l?r=n=0:1===l?(r=0,n=s-f):(r=l-2,n=ou(nu(lt(e),0),s-f)),s+r-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(o=Pt(c,n),i=0;i<n;i++)(a=f+i)in c&&ln(o,i,c[a]);if(o.length=n,r<n){for(i=f;i<s-n;i++)u=i+r,(a=i+n)in c?c[u]=c[a]:delete c[u];for(i=s;i>s-n+r;i--)delete c[i-1]}else if(r>n)for(i=s-n;i>f;i--)u=i+r-1,(a=i+n-1)in c?c[u]=c[a]:delete c[u];for(i=0;i<r;i++)c[i+f]=arguments[i+2];return c.length=s-n+r,o}});var iu=ir("Array").splice,au=Array.prototype,uu=function(t){var e=t.splice;return t===au||t instanceof Array&&e===au.splice?iu:e},cu=[].slice,su=/MSIE .\./.test(sr),fu=function(t){return function(e,r){var n=arguments.length>2,o=n?cu.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,o)}:e,r)}};Y({global:!0,bind:!0,forced:su},{setTimeout:fu(n.setTimeout),setInterval:fu(n.setInterval)});var lu,hu,vu,pu,yu=J.setTimeout,du=function(){function t(e){Br(this,t),lu.set(this,[]),hu.set(this,null),vu.set(this,null),this.delay=null,this.max=1/0,this.setOptions(e)}return Xr(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),Zr(this,vu)){for(var t=Zr(this,vu).object,e=Zr(this,vu).methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}tn(this,vu,null)}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?Zr(this,lu).push({fn:t}):Zr(this,lu).push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;Zr(this,lu).length>this.max&&this.flush(),null!=Zr(this,hu)&&(clearTimeout(Zr(this,hu)),tn(this,hu,null)),this.queue.length>0&&"number"==typeof this.delay&&tn(this,hu,yu((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;wn(t=uu(e=Zr(this,lu)).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(r&&r.replace)for(var i=0;i<r.replace.length;i++){var a=r.replace[i];o.push({name:a,original:e[a]}),n.replace(e,a)}return tn(n,vu,{object:e,methods:o}),n}}]),t}();lu=new tr,hu=new tr,vu=new tr;var gu=function(){function t(){Br(this,t),pu.set(this,{"*":[],add:[],remove:[],update:[]}),this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return Xr(t,[{key:"_trigger",value:function(t,e,r){var n,o;if("*"===t)throw new Error("Cannot trigger event *");wn(n=Ci(o=[]).call(o,Li(Zr(this,pu)[t]),Li(Zr(this,pu)["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&Zr(this,pu)[t].push(e)}},{key:"off",value:function(t,e){var r;Zr(this,pu)[t]=Pr(r=Zr(this,pu)[t]).call(r,(function(t){return t!==e}))}}]),t}();pu=new tr;ee("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Zi);var mu,bu=J.Set;function wu(t,e){var r;if(void 0===bo||null==ho(t)){if(ea(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Ou(t,e);var n=Co(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ao(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ou(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=lo(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Ou(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var xu,ku,Su,ju,Au=function(){function t(e){Br(this,t),mu.set(this,void 0),tn(this,mu,e)}return Xr(t,[{key:(mu=new tr,Bo),value:Jo.mark((function t(){var e,r,n,o,i;return Jo.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=wu(Zr(this,mu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Ja(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Jo.mark((function t(){var e,r,n,o,i;return Jo.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=wu(Zr(this,mu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Ja(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Jo.mark((function t(){var e,r,n,o;return Jo.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=wu(Zr(this,mu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Ja(r.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Jo.mark((function t(){var e,r,n,o;return Jo.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=wu(Zr(this,mu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Ja(r.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return jr(t=Li(Zr(this,mu))).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return jr(t=Li(Zr(this,mu))).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Li(Zr(this,mu))}},{key:"toObjectMap",value:function(){var t,e=xa(null),r=wu(Zr(this,mu));try{for(r.s();!(t=r.n()).done;){var n=Ja(t.value,2),o=n[0],i=n[1];e[o]=i}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new ta(Zr(this,mu))}},{key:"toIdSet",value:function(){return new bu(this.toIdArray())}},{key:"toItemSet",value:function(){return new bu(this.toItemArray())}},{key:"cache",value:function(){return new t(Li(Zr(this,mu)))}},{key:"distinct",value:function(t){var e,r=new bu,n=wu(Zr(this,mu));try{for(n.s();!(e=n.n()).done;){var o=Ja(e.value,2),i=o[0],a=o[1];r.add(t(a,i))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=Zr(this,mu);return new t(Ko({},Bo,Jo.mark((function t(){var n,o,i,a,u;return Jo.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=wu(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=10;break}if(i=Ja(o.value,2),a=i[0],u=i[1],!e(u,a)){t.next=8;break}return t.next=8,[a,u];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=wu(Zr(this,mu));try{for(r.s();!(e=r.n()).done;){var n=Ja(e.value,2),o=n[0];t(n[1],o)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=Zr(this,mu);return new t(Ko({},Bo,Jo.mark((function t(){var n,o,i,a,u;return Jo.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=wu(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=9;break}return i=Ja(o.value,2),a=i[0],u=i[1],t.next=7,[a,e(u,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=lo(Zr(this,mu)),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=Ja(r.value,2),a=i[0],u=i[1],c=t(u,a);c>o&&(o=c,n=u)}return n}},{key:"min",value:function(t){var e=lo(Zr(this,mu)),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=Ja(r.value,2),a=i[0],u=i[1],c=t(u,a);c<o&&(o=c,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=wu(Zr(this,mu));try{for(n.s();!(r=n.n()).done;){var o=Ja(r.value,2),i=o[0];e=t(e,o[1],i)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(Ko({},Bo,(function(){var t;return lo(vi(t=Li(Zr(r,mu))).call(t,(function(t,r){var n=Ja(t,2),o=n[0],i=n[1],a=Ja(r,2),u=a[0],c=a[1];return e(i,c,o,u)})))})))}}]),t}();function Eu(t,e){var r=yi(t);if(ao){var n=ao(t);e&&(n=Pr(n).call(n,(function(e){return kn(t,e).enumerable}))),r.push.apply(r,n)}return r}function _u(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)wn(r=Eu(Object(n),!0)).call(r,(function(e){Ko(t,e,n[e])}));else if(hn)an(t,hn(n));else{var o;wn(o=Eu(Object(n))).call(o,(function(e){on(t,e,kn(n,e))}))}}return t}function Iu(t,e){var r;if(void 0===bo||null==ho(t)){if(ea(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Tu(t,e);var n=Co(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ao(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Tu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=lo(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Tu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Pu(t){var e=function(){if("undefined"==typeof Reflect||!Go)return!1;if(Go.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Go(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=ha(t);if(e){var o=ha(this).constructor;r=Go(n,arguments,o)}else r=n.apply(this,arguments);return sa(this,r)}}var Lu,Du,Mu,Cu,Fu=function(t){ca(r,gu);var e=Pu(r);function r(t,n){var o;return Br(this,r),o=e.call(this),xu.set(ra(o),void 0),ku.set(ra(o),void 0),Su.set(ra(o),void 0),ju.set(ra(o),null),t&&!ea(t)&&(n=t,t=[]),tn(ra(o),xu,n||{}),tn(ra(o),ku,new ta),o.length=0,tn(ra(o),Su,Zr(ra(o),xu).fieldId||"id"),t&&t.length&&o.add(t),o.setOptions(n),o}return Xr(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?Zr(this,ju)&&(Zr(this,ju).destroy(),tn(this,ju,null)):(Zr(this,ju)||tn(this,ju,du.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Bi(t.queue)&&Zr(this,ju).setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,o=[];if(ea(t)){var i=jr(t).call(t,(function(t){return t[Zr(n,Su)]}));if(Ji(i).call(i,(function(t){return Zr(n,ku).has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),o.push(r)}else{if(!t||"object"!==Bi(t))throw new Error("Unknown dataType");r=this._addItem(t),o.push(r)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var r=this,n=[],o=[],i=[],a=[],u=Zr(this,Su),c=function(t){var e=t[u];if(null!=e&&Zr(r,ku).has(e)){var c=t,s=zi({},Zr(r,ku).get(e)),f=r._updateItem(c);o.push(f),a.push(c),i.push(s)}else{var l=r._addItem(t);n.push(l)}};if(ea(t))for(var s=0,f=t.length;s<f;s++)t[s]&&"object"===Bi(t[s])?c(t[s]):console.warn("Ignoring input item, which is not an object at index "+s);else{if(!t||"object"!==Bi(t))throw new Error("Unknown dataType");c(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var l={items:o,oldData:i,data:a};this._trigger("update",l,e)}return Ci(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var r,n=this;ea(t)||(t=[t]);var o=jr(r=jr(t).call(t,(function(t){var e=Zr(n,ku).get(t[Zr(n,Su)]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,o=e[Zr(n,Su)],i=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];return Ya.apply(void 0,Ci(e=[{},t]).call(e,n))}(e,r);return Zr(n,ku).set(o,i),{id:o,oldData:e,updatedData:i}}));if(o.length){var i={items:jr(o).call(o,(function(t){return t.id})),oldData:jr(o).call(o,(function(t){return t.oldData})),data:jr(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",i,e),i.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,o=void 0;tu(t)?(r=t,o=e):ea(t)?(n=t,o=e):o=t;var i=o&&"Object"===o.returnType?"Object":"Array",a=o&&Pr(o),u=[],c=void 0,s=void 0,f=void 0;if(null!=r)(c=Zr(this,ku).get(r))&&a&&!a(c)&&(c=void 0);else if(null!=n)for(var l=0,h=n.length;l<h;l++)null==(c=Zr(this,ku).get(n[l]))||a&&!a(c)||u.push(c);else for(var v,p=0,y=(s=Li(bi(v=Zr(this,ku)).call(v))).length;p<y;p++)f=s[p],null==(c=Zr(this,ku).get(f))||a&&!a(c)||u.push(c);if(o&&o.order&&null==r&&this._sort(u,o.order),o&&o.fields){var d=o.fields;if(null!=r&&null!=c)c=this._filterFields(c,d);else for(var g=0,m=u.length;g<m;g++)u[g]=this._filterFields(u[g],d)}if("Object"==i){for(var b={},w=0,O=u.length;w<O;w++){var x=u[w];b[x[Zr(this,Su)]]=x}return b}return null!=r?null!=c?c:null:u}},{key:"getIds",value:function(t){var e=Zr(this,ku),r=t&&Pr(t),n=t&&t.order,o=Li(bi(e).call(e)),i=[];if(r)if(n){for(var a=[],u=0,c=o.length;u<c;u++){var s=o[u],f=Zr(this,ku).get(s);null!=f&&r(f)&&a.push(f)}this._sort(a,n);for(var l=0,h=a.length;l<h;l++)i.push(a[l][Zr(this,Su)])}else for(var v=0,p=o.length;v<p;v++){var y=o[v],d=Zr(this,ku).get(y);null!=d&&r(d)&&i.push(d[Zr(this,Su)])}else if(n){for(var g=[],m=0,b=o.length;m<b;m++){var w=o[m];g.push(e.get(w))}this._sort(g,n);for(var O=0,x=g.length;O<x;O++)i.push(g[O][Zr(this,Su)])}else for(var k=0,S=o.length;k<S;k++){var j=o[k],A=e.get(j);null!=A&&i.push(A[Zr(this,Su)])}return i}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Pr(e),n=Zr(this,ku),o=Li(bi(n).call(n));if(e&&e.order)for(var i=this.get(e),a=0,u=i.length;a<u;a++){var c=i[a];t(c,c[Zr(this,Su)])}else for(var s=0,f=o.length;s<f;s++){var l=o[s],h=Zr(this,ku).get(l);null==h||r&&!r(h)||t(h,l)}}},{key:"map",value:function(t,e){for(var r=e&&Pr(e),n=[],o=Zr(this,ku),i=Li(bi(o).call(o)),a=0,u=i.length;a<u;a++){var c=i[a],s=Zr(this,ku).get(c);null==s||r&&!r(s)||n.push(t(s,c))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?zr(r=ea(e)?e:yi(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;vi(t).call(t,(function(t,e){var n=t[r],o=e[r];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");vi(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],o=ea(t)?t:[t],i=0,a=o.length;i<a;i++){var u=this._remove(o[i]);if(u){var c=u[Zr(this,Su)];null!=c&&(r.push(c),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(tu(t)?e=t:t&&"object"===Bi(t)&&(e=t[Zr(this,Su)]),null!=e&&Zr(this,ku).has(e)){var r=Zr(this,ku).get(e)||null;return Zr(this,ku).delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Li(bi(e=Zr(this,ku)).call(e)),n=[],o=0,i=r.length;o<i;o++)n.push(Zr(this,ku).get(r[o]));return Zr(this,ku).clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,o=null,i=Iu(ii(e=Zr(this,ku)).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u>o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,o=null,i=Iu(ii(e=Zr(this,ku)).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u<o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"distinct",value:function(t){for(var e=Zr(this,ku),r=Li(bi(e).call(e)),n=[],o=0,i=0,a=r.length;i<a;i++){for(var u=r[i],c=e.get(u)[t],s=!1,f=0;f<o;f++)if(n[f]==c){s=!0;break}s||void 0===c||(n[o]=c,o++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=wa()),t}(t,Zr(this,Su)),r=e[Zr(this,Su)];if(Zr(this,ku).has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return Zr(this,ku).set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[Zr(this,Su)];if(null==e)throw new Error("Cannot update item: item has no id (item: "+ei(t)+")");var r=Zr(this,ku).get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return Zr(this,ku).set(e,_u(_u({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=Zr(this,ku);return new Au(Ko({},Bo,Jo.mark((function r(){var n,o,i,a;return Jo.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Iu(t),r.prev=1,n.s();case 3:if((o=n.n()).done){r.next=11;break}if(i=o.value,null==(a=e.get(i))){r.next=9;break}return r.next=9,[i,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new Au(Ko({},Bo,$r(r=Wo(Zr(this,ku))).call(r,Zr(this,ku))))}}]),r}();function Ru(t,e){var r;if(void 0===bo||null==ho(t)){if(ea(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Nu(t,e);var n=Co(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ao(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Nu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=lo(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Nu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function zu(t){var e=function(){if("undefined"==typeof Reflect||!Go)return!1;if(Go.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Go(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=ha(t);if(e){var o=ha(this).constructor;r=Go(n,arguments,o)}else r=n.apply(this,arguments);return sa(this,r)}}xu=new tr,ku=new tr,Su=new tr,ju=new tr;var Gu=function(t){ca(r,gu);var e=zu(r);function r(t,n){var o,i;return Br(this,r),(i=e.call(this)).length=0,Lu.set(ra(i),void 0),Du.set(ra(i),void 0),Mu.set(ra(i),new bu),Cu.set(ra(i),void 0),tn(ra(i),Cu,n||{}),tn(ra(i),Lu,$r(o=i._onEvent).call(o,ra(i))),i.setData(t),i}return Xr(r,[{key:"setData",value:function(t){if(Zr(this,Du)){Zr(this,Du).off&&Zr(this,Du).off("*",Zr(this,Lu));var e=Zr(this,Du).getIds({filter:Pr(Zr(this,Cu))}),r=Zr(this,Du).get(e);Zr(this,Mu).clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){tn(this,Du,t);for(var n=Zr(this,Du).getIds({filter:Pr(Zr(this,Cu))}),o=0,i=n.length;o<i;o++){var a=n[o];Zr(this,Mu).add(a)}this.length=n.length,this._trigger("add",{items:n})}else tn(this,Du,new Fu);Zr(this,Du).on&&Zr(this,Du).on("*",Zr(this,Lu))}},{key:"refresh",value:function(){for(var t=Zr(this,Du).getIds({filter:Pr(Zr(this,Cu))}),e=Li(Zr(this,Mu)),r={},n=[],o=[],i=[],a=0,u=t.length;a<u;a++){var c=t[a];r[c]=!0,Zr(this,Mu).has(c)||(n.push(c),Zr(this,Mu).add(c))}for(var s=0,f=e.length;s<f;s++){var l=e[s],h=Zr(this,Du).get(l);null==h?console.error("If you see this, report it please."):r[l]||(o.push(l),i.push(h),Zr(this,Mu).delete(l))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:i})}},{key:"get",value:function(t,e){if(null==Zr(this,Du))return null;var r,n=null;tu(t)||ea(t)?(n=t,r=e):r=t;var o=zi({},Zr(this,Cu),r),i=Pr(Zr(this,Cu)),a=r&&Pr(r);return i&&a&&(o.filter=function(t){return i(t)&&a(t)}),null==n?Zr(this,Du).get(o):Zr(this,Du).get(n,o)}},{key:"getIds",value:function(t){if(Zr(this,Du).length){var e,r=Pr(Zr(this,Cu)),n=null!=t?Pr(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,Zr(this,Du).getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(Zr(this,Du)){var r,n,o=Pr(Zr(this,Cu)),i=e&&Pr(e);n=i?o?function(t){return o(t)&&i(t)}:i:o,wn(r=Zr(this,Du)).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(Zr(this,Du)){var r,n,o=Pr(Zr(this,Cu)),i=e&&Pr(e);return n=i?o?function(t){return o(t)&&i(t)}:i:o,jr(r=Zr(this,Du)).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return Zr(this,Du).getDataSet()}},{key:"stream",value:function(t){var e;return Zr(this,Du).stream(t||Ko({},Bo,$r(e=bi(Zr(this,Mu))).call(e,Zr(this,Mu))))}},{key:"dispose",value:function(){var t;(null===(t=Zr(this,Du))||void 0===t?void 0:t.off)&&Zr(this,Du).off("*",Zr(this,Lu));var e,n="This data view has already been disposed of.",o={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},i=Ru($a(r.prototype));try{for(i.s();!(e=i.n()).done;){var a=e.value;on(this,a,o)}}catch(t){i.e(t)}finally{i.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&Zr(this,Du)){var n=e.items,o=[],i=[],a=[],u=[],c=[],s=[];switch(t){case"add":for(var f=0,l=n.length;f<l;f++){var h=n[f];this.get(h)&&(Zr(this,Mu).add(h),o.push(h))}break;case"update":for(var v=0,p=n.length;v<p;v++){var y=n[v];this.get(y)?Zr(this,Mu).has(y)?(i.push(y),c.push(e.data[v]),u.push(e.oldData[v])):(Zr(this,Mu).add(y),o.push(y)):Zr(this,Mu).has(y)&&(Zr(this,Mu).delete(y),a.push(y),s.push(e.oldData[v]))}break;case"remove":for(var d=0,g=n.length;d<g;d++){var m=n[d];Zr(this,Mu).has(m)&&(Zr(this,Mu).delete(m),a.push(m),s.push(e.oldData[d]))}}this.length+=o.length-a.length,o.length&&this._trigger("add",{items:o},r),i.length&&this._trigger("update",{items:i,oldData:u,data:c},r),a.length&&this._trigger("remove",{items:a,oldData:s},r)}}}]),r}();Lu=new tr,Du=new tr,Mu=new tr,Cu=new tr;export{Qa as DELETE,Fu as DataSet,Au as DataStream,Gu as DataView,du as Queue,en as createNewDataPipeFrom};
//# sourceMappingURL=vis-data.min.js.map
