/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.0.1
 * @date    2020-10-13T17:07:07.867Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&r.path)}},r.exports),r.exports}var n=function(t){return t&&t.Math==Math&&t},o=n("object"==typeof globalThis&&globalThis)||n("object"==typeof window&&window)||n("object"==typeof self&&self)||n("object"==typeof e&&e)||Function("return this")(),i=function(t){try{return!!t()}catch(t){return!0}},a=!i((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),u=function(t){return"object"==typeof t?null!==t:"function"==typeof t},c=o.document,f=u(c)&&u(c.createElement),s=function(t){return f?c.createElement(t):{}},l=!a&&!i((function(){return 7!=Object.defineProperty(s("div"),"a",{get:function(){return 7}}).a})),h=function(t){if(!u(t))throw TypeError(String(t)+" is not an object");return t},v=function(t,e){if(!u(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!u(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!u(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!u(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},p=Object.defineProperty,y={f:a?p:function(t,e,r){if(h(t),e=v(e,!0),h(r),l)try{return p(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},d=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},g=a?function(t,e,r){return y.f(t,e,d(1,r))}:function(t,e,r){return t[e]=r,t},m=function(t,e,r,n){n&&n.enumerable?t[e]=r:g(t,e,r)},b=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:m(t,n,e[n],r);return t},w={},O={}.hasOwnProperty,x=function(t,e){return O.call(t,e)},k=0,S=Math.random(),j=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++k+S).toString(36)},A=!i((function(){return Object.isExtensible(Object.preventExtensions({}))})),E=r((function(t){var e=y.f,r=j("meta"),n=0,o=Object.isExtensible||function(){return!0},i=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!u(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!x(t,r)){if(!o(t))return"F";if(!e)return"E";i(t)}return t[r].objectID},getWeakData:function(t,e){if(!x(t,r)){if(!o(t))return!0;if(!e)return!1;i(t)}return t[r].weakData},onFreeze:function(t){return A&&a.REQUIRED&&o(t)&&!x(t,r)&&i(t),t}};w[r]=!0})),_={}.propertyIsEnumerable,I=Object.getOwnPropertyDescriptor,T={f:I&&!_.call({1:2},1)?function(t){var e=I(this,t);return!!e&&e.enumerable}:_},P={}.toString,D=function(t){return P.call(t).slice(8,-1)},L="".split,M=i((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==D(t)?L.call(t,""):Object(t)}:Object,C=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},F=function(t){return M(C(t))},R=Object.getOwnPropertyDescriptor,N={f:a?R:function(t,e){if(t=F(t),e=v(e,!0),l)try{return R(t,e)}catch(t){}if(x(t,e))return d(!T.f.call(t,e),t[e])}},z=/#|\.prototype\./,G=function(t,e){var r=V[U(t)];return r==W||r!=q&&("function"==typeof e?i(e):!!e)},U=G.normalize=function(t){return String(t).replace(z,".").toLowerCase()},V=G.data={},q=G.NATIVE="N",W=G.POLYFILL="P",J=G,$={},Q=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},B=function(t,e,r){if(Q(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,o){return t.call(e,r,n,o)}}return function(){return t.apply(e,arguments)}},K=N.f,Y=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},H=function(t,e){var r,n,i,a,u,c,f,s,l=t.target,h=t.global,v=t.stat,p=t.proto,y=h?o:v?o[l]:(o[l]||{}).prototype,d=h?$:$[l]||($[l]={}),m=d.prototype;for(i in e)r=!J(h?i:l+(v?".":"#")+i,t.forced)&&y&&x(y,i),u=d[i],r&&(c=t.noTargetGet?(s=K(y,i))&&s.value:y[i]),a=r&&c?c:e[i],r&&typeof u==typeof a||(f=t.bind&&r?B(a,o):t.wrap&&r?Y(a):p&&"function"==typeof a?B(Function.call,a):a,(t.sham||a&&a.sham||u&&u.sham)&&g(f,"sham",!0),d[i]=f,p&&(x($,n=l+"Prototype")||g($,n,{}),$[n][i]=a,t.real&&m&&!m[i]&&g(m,i,a)))},X="__core-js_shared__",Z=o[X]||function(t,e){try{g(o,t,e)}catch(r){o[t]=e}return e}(X,{}),tt=r((function(t){(t.exports=function(t,e){return Z[t]||(Z[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),et=!!Object.getOwnPropertySymbols&&!i((function(){return!String(Symbol())})),rt=et&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,nt=tt("wks"),ot=o.Symbol,it=rt?ot:ot&&ot.withoutSetter||j,at=function(t){return x(nt,t)||(et&&x(ot,t)?nt[t]=ot[t]:nt[t]=it("Symbol."+t)),nt[t]},ut={},ct=at("iterator"),ft=Array.prototype,st=function(t){return void 0!==t&&(ut.Array===t||ft[ct]===t)},lt=Math.ceil,ht=Math.floor,vt=function(t){return isNaN(t=+t)?0:(t>0?ht:lt)(t)},pt=Math.min,yt=function(t){return t>0?pt(vt(t),9007199254740991):0},dt={};dt[at("toStringTag")]="z";var gt="[object z]"===String(dt),mt=at("toStringTag"),bt="Arguments"==D(function(){return arguments}()),wt=gt?D:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),mt))?r:bt?D(e):"Object"==(n=D(e))&&"function"==typeof e.callee?"Arguments":n},Ot=at("iterator"),xt=function(t){if(null!=t)return t[Ot]||t["@@iterator"]||ut[wt(t)]},kt=function(t,e,r,n){try{return n?e(h(r)[0],r[1]):e(r)}catch(e){var o=t.return;throw void 0!==o&&h(o.call(t)),e}},St=r((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,r,n,o,i){var a,u,c,f,s,l,v,p=B(r,n,o?2:1);if(i)a=t;else{if("function"!=typeof(u=xt(t)))throw TypeError("Target is not iterable");if(st(u)){for(c=0,f=yt(t.length);f>c;c++)if((s=o?p(h(v=t[c])[0],v[1]):p(t[c]))&&s instanceof e)return s;return new e(!1)}a=u.call(t)}for(l=a.next;!(v=l.call(a)).done;)if("object"==typeof(s=kt(a,p,v.value,o))&&s&&s instanceof e)return s;return new e(!1)}).stop=function(t){return new e(!0,t)}})),jt=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},At=gt?{}.toString:function(){return"[object "+wt(this)+"]"},Et=y.f,_t=at("toStringTag"),It=function(t,e,r,n){if(t){var o=r?t:t.prototype;x(o,_t)||Et(o,_t,{configurable:!0,value:e}),n&&!gt&&g(o,"toString",At)}},Tt=function(t){return Object(C(t))},Pt=Array.isArray||function(t){return"Array"==D(t)},Dt=at("species"),Lt=function(t,e){var r;return Pt(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!Pt(r.prototype)?u(r)&&null===(r=r[Dt])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)},Mt=[].push,Ct=function(t){var e=1==t,r=2==t,n=3==t,o=4==t,i=6==t,a=5==t||i;return function(u,c,f,s){for(var l,h,v=Tt(u),p=M(v),y=B(c,f,3),d=yt(p.length),g=0,m=s||Lt,b=e?m(u,d):r?m(u,0):void 0;d>g;g++)if((a||g in p)&&(h=y(l=p[g],g,v),t))if(e)b[g]=h;else if(h)switch(t){case 3:return!0;case 5:return l;case 6:return g;case 2:Mt.call(b,l)}else if(o)return!1;return i?-1:n||o?o:b}},Ft={forEach:Ct(0),map:Ct(1),filter:Ct(2),some:Ct(3),every:Ct(4),find:Ct(5),findIndex:Ct(6)},Rt=Function.toString;"function"!=typeof Z.inspectSource&&(Z.inspectSource=function(t){return Rt.call(t)});var Nt,zt,Gt,Ut=Z.inspectSource,Vt=o.WeakMap,qt="function"==typeof Vt&&/native code/.test(Ut(Vt)),Wt=tt("keys"),Jt=function(t){return Wt[t]||(Wt[t]=j(t))},$t=o.WeakMap;if(qt){var Qt=new $t,Bt=Qt.get,Kt=Qt.has,Yt=Qt.set;Nt=function(t,e){return Yt.call(Qt,t,e),e},zt=function(t){return Bt.call(Qt,t)||{}},Gt=function(t){return Kt.call(Qt,t)}}else{var Ht=Jt("state");w[Ht]=!0,Nt=function(t,e){return g(t,Ht,e),e},zt=function(t){return x(t,Ht)?t[Ht]:{}},Gt=function(t){return x(t,Ht)}}var Xt={set:Nt,get:zt,has:Gt,enforce:function(t){return Gt(t)?zt(t):Nt(t,{})},getterFor:function(t){return function(e){var r;if(!u(e)||(r=zt(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},Zt=y.f,te=Ft.forEach,ee=Xt.set,re=Xt.getterFor,ne=function(t,e,r){var n,c=-1!==t.indexOf("Map"),f=-1!==t.indexOf("Weak"),s=c?"set":"add",l=o[t],h=l&&l.prototype,v={};if(a&&"function"==typeof l&&(f||h.forEach&&!i((function(){(new l).entries().next()})))){n=e((function(e,r){ee(jt(e,n,t),{type:t,collection:new l}),null!=r&&St(r,e[s],e,c)}));var p=re(t);te(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in h)||f&&"clear"==t||g(n.prototype,t,(function(r,n){var o=p(this).collection;if(!e&&f&&!u(r))return"get"==t&&void 0;var i=o[t](0===r?0:r,n);return e?this:i}))})),f||Zt(n.prototype,"size",{configurable:!0,get:function(){return p(this).collection.size}})}else n=r.getConstructor(e,t,c,s),E.REQUIRED=!0;return It(n,t,!1,!0),v[t]=n,H({global:!0,forced:!0},v),f||r.setStrong(n,t,c),n},oe=E.getWeakData,ie=Xt.set,ae=Xt.getterFor,ue=Ft.find,ce=Ft.findIndex,fe=0,se=function(t){return t.frozen||(t.frozen=new le)},le=function(){this.entries=[]},he=function(t,e){return ue(t.entries,(function(t){return t[0]===e}))};le.prototype={get:function(t){var e=he(this,t);if(e)return e[1]},has:function(t){return!!he(this,t)},set:function(t,e){var r=he(this,t);r?r[1]=e:this.entries.push([t,e])},delete:function(t){var e=ce(this.entries,(function(e){return e[0]===t}));return~e&&this.entries.splice(e,1),!!~e}};var ve,pe,ye,de={getConstructor:function(t,e,r,n){var o=t((function(t,i){jt(t,o,e),ie(t,{type:e,id:fe++,frozen:void 0}),null!=i&&St(i,t[n],t,r)})),i=ae(e),a=function(t,e,r){var n=i(t),o=oe(h(e),!0);return!0===o?se(n).set(e,r):o[n.id]=r,t};return b(o.prototype,{delete:function(t){var e=i(this);if(!u(t))return!1;var r=oe(t);return!0===r?se(e).delete(t):r&&x(r,e.id)&&delete r[e.id]},has:function(t){var e=i(this);if(!u(t))return!1;var r=oe(t);return!0===r?se(e).has(t):r&&x(r,e.id)}}),b(o.prototype,r?{get:function(t){var e=i(this);if(u(t)){var r=oe(t);return!0===r?se(e).get(t):r?r[e.id]:void 0}},set:function(t,e){return a(this,t,e)}}:{add:function(t){return a(this,t,!0)}}),o}},ge=(r((function(t){var e,r=Xt.enforce,n=!o.ActiveXObject&&"ActiveXObject"in o,i=Object.isExtensible,a=function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}},c=t.exports=ne("WeakMap",a,de);if(qt&&n){e=de.getConstructor(a,"WeakMap",!0),E.REQUIRED=!0;var f=c.prototype,s=f.delete,l=f.has,h=f.get,v=f.set;b(f,{delete:function(t){if(u(t)&&!i(t)){var n=r(this);return n.frozen||(n.frozen=new e),s.call(this,t)||n.frozen.delete(t)}return s.call(this,t)},has:function(t){if(u(t)&&!i(t)){var n=r(this);return n.frozen||(n.frozen=new e),l.call(this,t)||n.frozen.has(t)}return l.call(this,t)},get:function(t){if(u(t)&&!i(t)){var n=r(this);return n.frozen||(n.frozen=new e),l.call(this,t)?h.call(this,t):n.frozen.get(t)}return h.call(this,t)},set:function(t,n){if(u(t)&&!i(t)){var o=r(this);o.frozen||(o.frozen=new e),l.call(this,t)?v.call(this,t,n):o.frozen.set(t,n)}else v.call(this,t,n);return this}})}})),!i((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype}))),me=Jt("IE_PROTO"),be=Object.prototype,we=ge?Object.getPrototypeOf:function(t){return t=Tt(t),x(t,me)?t[me]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?be:null},Oe=(at("iterator"),!1);[].keys&&("next"in(ye=[].keys())?(pe=we(we(ye)))!==Object.prototype&&(ve=pe):Oe=!0),null==ve&&(ve={});var xe,ke={IteratorPrototype:ve,BUGGY_SAFARI_ITERATORS:Oe},Se=Math.max,je=Math.min,Ae=function(t,e){var r=vt(t);return r<0?Se(r+e,0):je(r,e)},Ee=function(t){return function(e,r,n){var o,i=F(e),a=yt(i.length),u=Ae(n,a);if(t&&r!=r){for(;a>u;)if((o=i[u++])!=o)return!0}else for(;a>u;u++)if((t||u in i)&&i[u]===r)return t||u||0;return!t&&-1}},_e={includes:Ee(!0),indexOf:Ee(!1)},Ie=_e.indexOf,Te=function(t,e){var r,n=F(t),o=0,i=[];for(r in n)!x(w,r)&&x(n,r)&&i.push(r);for(;e.length>o;)x(n,r=e[o++])&&(~Ie(i,r)||i.push(r));return i},Pe=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],De=Object.keys||function(t){return Te(t,Pe)},Le=a?Object.defineProperties:function(t,e){h(t);for(var r,n=De(e),o=n.length,i=0;o>i;)y.f(t,r=n[i++],e[r]);return t},Me=function(t){return"function"==typeof t?t:void 0},Ce=function(t,e){return arguments.length<2?Me($[t])||Me(o[t]):$[t]&&$[t][e]||o[t]&&o[t][e]},Fe=Ce("document","documentElement"),Re=Jt("IE_PROTO"),Ne=function(){},ze=function(t){return"<script>"+t+"</"+"script>"},Ge=function(){try{xe=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Ge=xe?function(t){t.write(ze("")),t.close();var e=t.parentWindow.Object;return t=null,e}(xe):((e=s("iframe")).style.display="none",Fe.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(ze("document.F=Object")),t.close(),t.F);for(var r=Pe.length;r--;)delete Ge.prototype[Pe[r]];return Ge()};w[Re]=!0;var Ue=Object.create||function(t,e){var r;return null!==t?(Ne.prototype=h(t),r=new Ne,Ne.prototype=null,r[Re]=t):r=Ge(),void 0===e?r:Le(r,e)},Ve=ke.IteratorPrototype,qe=function(){return this},We=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return h(r),function(t){if(!u(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),Je=ke.IteratorPrototype,$e=ke.BUGGY_SAFARI_ITERATORS,Qe=at("iterator"),Be="keys",Ke="values",Ye="entries",He=function(){return this},Xe=function(t,e,r,n,o,i,a){!function(t,e,r){var n=e+" Iterator";t.prototype=Ue(Ve,{next:d(1,r)}),It(t,n,!1,!0),ut[n]=qe}(r,e,n);var u,c,f,s=function(t){if(t===o&&y)return y;if(!$e&&t in v)return v[t];switch(t){case Be:case Ke:case Ye:return function(){return new r(this,t)}}return function(){return new r(this)}},l=e+" Iterator",h=!1,v=t.prototype,p=v[Qe]||v["@@iterator"]||o&&v[o],y=!$e&&p||s(o),b="Array"==e&&v.entries||p;if(b&&(u=we(b.call(new t)),Je!==Object.prototype&&u.next&&(It(u,l,!0,!0),ut[l]=He)),o==Ke&&p&&p.name!==Ke&&(h=!0,y=function(){return p.call(this)}),a&&v[Qe]!==y&&g(v,Qe,y),ut[e]=y,o)if(c={values:s(Ke),keys:i?y:s(Be),entries:s(Ye)},a)for(f in c)($e||h||!(f in v))&&m(v,f,c[f]);else H({target:e,proto:!0,forced:$e||h},c);return c},Ze="Array Iterator",tr=Xt.set,er=Xt.getterFor(Ze);Xe(Array,"Array",(function(t,e){tr(this,{type:Ze,target:F(t),index:0,kind:e})}),(function(){var t=er(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");ut.Arguments=ut.Array;var rr=at("toStringTag");for(var nr in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var or=o[nr],ir=or&&or.prototype;ir&&wt(ir)!==rr&&g(ir,rr,nr),ut[nr]=ut.Array}var ar=$.WeakMap,ur=function(t,e,r,n,o,i,a,u){for(var c,f=o,s=0,l=!!a&&B(a,u,3);s<n;){if(s in r){if(c=l?l(r[s],s,e):r[s],i>0&&Pt(c))f=ur(t,e,c,yt(c.length),f,i-1)-1;else{if(f>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[f]=c}f++}s++}return f},cr=ur;H({target:"Array",proto:!0},{flatMap:function(t){var e,r=Tt(this),n=yt(r.length);return Q(t),(e=Lt(r,0)).length=cr(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var fr,sr,lr=function(t){return $[t+"Prototype"]},hr=lr("Array").flatMap,vr=Array.prototype,pr=function(t){var e=t.flatMap;return t===vr||t instanceof Array&&e===vr.flatMap?hr:e},yr=Ce("navigator","userAgent")||"",dr=o.process,gr=dr&&dr.versions,mr=gr&&gr.v8;mr?sr=(fr=mr.split("."))[0]+fr[1]:yr&&(!(fr=yr.match(/Edge\/(\d+)/))||fr[1]>=74)&&(fr=yr.match(/Chrome\/(\d+)/))&&(sr=fr[1]);var br=sr&&+sr,wr=at("species"),Or=function(t){return br>=51||!i((function(){var e=[];return(e.constructor={})[wr]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},xr=Object.defineProperty,kr={},Sr=function(t){throw t},jr=function(t,e){if(x(kr,t))return kr[t];e||(e={});var r=[][t],n=!!x(e,"ACCESSORS")&&e.ACCESSORS,o=x(e,0)?e[0]:Sr,u=x(e,1)?e[1]:void 0;return kr[t]=!!r&&!i((function(){if(n&&!a)return!0;var t={length:-1};n?xr(t,1,{enumerable:!0,get:Sr}):t[1]=1,r.call(t,o,u)}))},Ar=Ft.map,Er=Or("map"),_r=jr("map");H({target:"Array",proto:!0,forced:!Er||!_r},{map:function(t){return Ar(this,t,arguments.length>1?arguments[1]:void 0)}});var Ir=lr("Array").map,Tr=Array.prototype,Pr=function(t){var e=t.map;return t===Tr||t instanceof Array&&e===Tr.map?Ir:e},Dr=Ft.filter,Lr=Or("filter"),Mr=jr("filter");H({target:"Array",proto:!0,forced:!Lr||!Mr},{filter:function(t){return Dr(this,t,arguments.length>1?arguments[1]:void 0)}});var Cr=lr("Array").filter,Fr=Array.prototype,Rr=function(t){var e=t.filter;return t===Fr||t instanceof Array&&e===Fr.filter?Cr:e},Nr=function(t){return function(e,r,n,o){Q(r);var i=Tt(e),a=M(i),u=yt(i.length),c=t?u-1:0,f=t?-1:1;if(n<2)for(;;){if(c in a){o=a[c],c+=f;break}if(c+=f,t?c<0:u<=c)throw TypeError("Reduce of empty array with no initial value")}for(;t?c>=0:u>c;c+=f)c in a&&(o=r(o,a[c],c,i));return o}},zr=function(t,e){var r=[][t];return!!r&&i((function(){r.call(null,e||function(){throw 1},1)}))},Gr={left:Nr(!1),right:Nr(!0)}.left,Ur=zr("reduce"),Vr=jr("reduce",{1:0});H({target:"Array",proto:!0,forced:!Ur||!Vr},{reduce:function(t){return Gr(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var qr=lr("Array").reduce,Wr=Array.prototype,Jr=function(t){var e=t.reduce;return t===Wr||t instanceof Array&&e===Wr.reduce?qr:e},$r=[].slice,Qr={},Br=function(t,e,r){if(!(e in Qr)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";Qr[e]=Function("C,a","return new C("+n.join(",")+")")}return Qr[e](t,r)},Kr=Function.bind||function(t){var e=Q(this),r=$r.call(arguments,1),n=function(){var o=r.concat($r.call(arguments));return this instanceof n?Br(e,o.length,o):e.apply(t,o)};return u(e.prototype)&&(n.prototype=e.prototype),n};H({target:"Function",proto:!0},{bind:Kr});var Yr=lr("Function").bind,Hr=Function.prototype,Xr=function(t){var e=t.bind;return t===Hr||t instanceof Function&&e===Hr.bind?Yr:e};var Zr=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};H({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperty:y.f});var tn=r((function(t){var e=$.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),en=tn;function rn(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),en(t,n.key,n)}}var nn,on=function(t,e,r){return e&&rn(t.prototype,e),r&&rn(t,r),t};
/*! *****************************************************************************
	Copyright (c) Microsoft Corporation.

	Permission to use, copy, modify, and/or distribute this software for any
	purpose with or without fee is hereby granted.

	THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
	REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
	INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
	LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
	OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
	PERFORMANCE OF THIS SOFTWARE.
	***************************************************************************** */function an(t,e){if(!e.has(t))throw new TypeError("attempted to get private field on non-instance");return e.get(t)}function un(t,e,r){if(!e.has(t))throw new TypeError("attempted to set private field on non-instance");return e.set(t,r),r}var cn=function(){function t(e,r,n){var o,i,a;Zr(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:Xr(o=this._add).call(o,this),remove:Xr(i=this._remove).call(i,this),update:Xr(a=this._update).call(a,this)}}return on(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return Jr(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),fn=function(){function t(e){Zr(this,t),this._source=e,nn.set(this,[])}return on(t,[{key:"filter",value:function(t){return an(this,nn).push((function(e){return Rr(e).call(e,t)})),this}},{key:"map",value:function(t){return an(this,nn).push((function(e){return Pr(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return an(this,nn).push((function(e){return pr(e).call(e,t)})),this}},{key:"to",value:function(t){return new cn(this._source,an(this,nn),t)}}]),t}();nn=new ar;var sn=tn;H({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperties:Le});var ln=r((function(t){var e=$.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),hn=Pe.concat("length","prototype"),vn={f:Object.getOwnPropertyNames||function(t){return Te(t,hn)}},pn={f:Object.getOwnPropertySymbols},yn=Ce("Reflect","ownKeys")||function(t){var e=vn.f(h(t)),r=pn.f;return r?e.concat(r(t)):e},dn=function(t,e,r){var n=v(e);n in t?y.f(t,n,d(0,r)):t[n]=r};H({target:"Object",stat:!0,sham:!a},{getOwnPropertyDescriptors:function(t){for(var e,r,n=F(t),o=N.f,i=yn(n),a={},u=0;i.length>u;)void 0!==(r=o(n,e=i[u++]))&&dn(a,e,r);return a}});var gn=$.Object.getOwnPropertyDescriptors,mn=Ft.forEach,bn=zr("forEach"),wn=jr("forEach"),On=bn&&wn?[].forEach:function(t){return mn(this,t,arguments.length>1?arguments[1]:void 0)};H({target:"Array",proto:!0,forced:[].forEach!=On},{forEach:On});var xn=lr("Array").forEach,kn=Array.prototype,Sn={DOMTokenList:!0,NodeList:!0},jn=function(t){var e=t.forEach;return t===kn||t instanceof Array&&e===kn.forEach||Sn.hasOwnProperty(wt(t))?xn:e},An=N.f,En=i((function(){An(1)}));H({target:"Object",stat:!0,forced:!a||En,sham:!a},{getOwnPropertyDescriptor:function(t,e){return An(F(t),e)}});var _n=r((function(t){var e=$.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),In=vn.f,Tn={}.toString,Pn="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Dn={f:function(t){return Pn&&"[object Window]"==Tn.call(t)?function(t){try{return In(t)}catch(t){return Pn.slice()}}(t):In(F(t))}},Ln={f:at},Mn=y.f,Cn=function(t){var e=$.Symbol||($.Symbol={});x(e,t)||Mn(e,t,{value:Ln.f(t)})},Fn=Ft.forEach,Rn=Jt("hidden"),Nn="Symbol",zn=at("toPrimitive"),Gn=Xt.set,Un=Xt.getterFor(Nn),Vn=Object.prototype,qn=o.Symbol,Wn=Ce("JSON","stringify"),Jn=N.f,$n=y.f,Qn=Dn.f,Bn=T.f,Kn=tt("symbols"),Yn=tt("op-symbols"),Hn=tt("string-to-symbol-registry"),Xn=tt("symbol-to-string-registry"),Zn=tt("wks"),to=o.QObject,eo=!to||!to.prototype||!to.prototype.findChild,ro=a&&i((function(){return 7!=Ue($n({},"a",{get:function(){return $n(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Jn(Vn,e);n&&delete Vn[e],$n(t,e,r),n&&t!==Vn&&$n(Vn,e,n)}:$n,no=function(t,e){var r=Kn[t]=Ue(qn.prototype);return Gn(r,{type:Nn,tag:t,description:e}),a||(r.description=e),r},oo=rt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof qn},io=function(t,e,r){t===Vn&&io(Yn,e,r),h(t);var n=v(e,!0);return h(r),x(Kn,n)?(r.enumerable?(x(t,Rn)&&t[Rn][n]&&(t[Rn][n]=!1),r=Ue(r,{enumerable:d(0,!1)})):(x(t,Rn)||$n(t,Rn,d(1,{})),t[Rn][n]=!0),ro(t,n,r)):$n(t,n,r)},ao=function(t,e){h(t);var r=F(e),n=De(r).concat(so(r));return Fn(n,(function(e){a&&!uo.call(r,e)||io(t,e,r[e])})),t},uo=function(t){var e=v(t,!0),r=Bn.call(this,e);return!(this===Vn&&x(Kn,e)&&!x(Yn,e))&&(!(r||!x(this,e)||!x(Kn,e)||x(this,Rn)&&this[Rn][e])||r)},co=function(t,e){var r=F(t),n=v(e,!0);if(r!==Vn||!x(Kn,n)||x(Yn,n)){var o=Jn(r,n);return!o||!x(Kn,n)||x(r,Rn)&&r[Rn][n]||(o.enumerable=!0),o}},fo=function(t){var e=Qn(F(t)),r=[];return Fn(e,(function(t){x(Kn,t)||x(w,t)||r.push(t)})),r},so=function(t){var e=t===Vn,r=Qn(e?Yn:F(t)),n=[];return Fn(r,(function(t){!x(Kn,t)||e&&!x(Vn,t)||n.push(Kn[t])})),n};if(et||(m((qn=function(){if(this instanceof qn)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=j(t),r=function(t){this===Vn&&r.call(Yn,t),x(this,Rn)&&x(this[Rn],e)&&(this[Rn][e]=!1),ro(this,e,d(1,t))};return a&&eo&&ro(Vn,e,{configurable:!0,set:r}),no(e,t)}).prototype,"toString",(function(){return Un(this).tag})),m(qn,"withoutSetter",(function(t){return no(j(t),t)})),T.f=uo,y.f=io,N.f=co,vn.f=Dn.f=fo,pn.f=so,Ln.f=function(t){return no(at(t),t)},a&&$n(qn.prototype,"description",{configurable:!0,get:function(){return Un(this).description}})),H({global:!0,wrap:!0,forced:!et,sham:!et},{Symbol:qn}),Fn(De(Zn),(function(t){Cn(t)})),H({target:Nn,stat:!0,forced:!et},{for:function(t){var e=String(t);if(x(Hn,e))return Hn[e];var r=qn(e);return Hn[e]=r,Xn[r]=e,r},keyFor:function(t){if(!oo(t))throw TypeError(t+" is not a symbol");if(x(Xn,t))return Xn[t]},useSetter:function(){eo=!0},useSimple:function(){eo=!1}}),H({target:"Object",stat:!0,forced:!et,sham:!a},{create:function(t,e){return void 0===e?Ue(t):ao(Ue(t),e)},defineProperty:io,defineProperties:ao,getOwnPropertyDescriptor:co}),H({target:"Object",stat:!0,forced:!et},{getOwnPropertyNames:fo,getOwnPropertySymbols:so}),H({target:"Object",stat:!0,forced:i((function(){pn.f(1)}))},{getOwnPropertySymbols:function(t){return pn.f(Tt(t))}}),Wn){var lo=!et||i((function(){var t=qn();return"[null]"!=Wn([t])||"{}"!=Wn({a:t})||"{}"!=Wn(Object(t))}));H({target:"JSON",stat:!0,forced:lo},{stringify:function(t,e,r){for(var n,o=[t],i=1;arguments.length>i;)o.push(arguments[i++]);if(n=e,(u(e)||void 0!==t)&&!oo(t))return Pt(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!oo(e))return e}),o[1]=e,Wn.apply(null,o)}})}qn.prototype[zn]||g(qn.prototype,zn,qn.prototype.valueOf),It(qn,Nn),w[Rn]=!0;var ho=$.Object.getOwnPropertySymbols,vo=function(t){return function(e,r){var n,o,i=String(C(e)),a=vt(r),u=i.length;return a<0||a>=u?t?"":void 0:(n=i.charCodeAt(a))<55296||n>56319||a+1===u||(o=i.charCodeAt(a+1))<56320||o>57343?t?i.charAt(a):n:t?i.slice(a,a+2):o-56320+(n-55296<<10)+65536}},po={codeAt:vo(!1),charAt:vo(!0)}.charAt,yo="String Iterator",go=Xt.set,mo=Xt.getterFor(yo);Xe(String,"String",(function(t){go(this,{type:yo,string:String(t),index:0})}),(function(){var t,e=mo(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=po(r,n),e.index+=t.length,{value:t,done:!1})}));var bo=function(t){var e=xt(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return h(e.call(t))},wo=xt,Oo=at("isConcatSpreadable"),xo=9007199254740991,ko="Maximum allowed index exceeded",So=br>=51||!i((function(){var t=[];return t[Oo]=!1,t.concat()[0]!==t})),jo=Or("concat"),Ao=function(t){if(!u(t))return!1;var e=t[Oo];return void 0!==e?!!e:Pt(t)};H({target:"Array",proto:!0,forced:!So||!jo},{concat:function(t){var e,r,n,o,i,a=Tt(this),u=Lt(a,0),c=0;for(e=-1,n=arguments.length;e<n;e++)if(Ao(i=-1===e?a:arguments[e])){if(c+(o=yt(i.length))>xo)throw TypeError(ko);for(r=0;r<o;r++,c++)r in i&&dn(u,c,i[r])}else{if(c>=xo)throw TypeError(ko);dn(u,c++,i)}return u.length=c,u}}),Cn("asyncIterator"),Cn("hasInstance"),Cn("isConcatSpreadable"),Cn("iterator"),Cn("match"),Cn("matchAll"),Cn("replace"),Cn("search"),Cn("species"),Cn("split"),Cn("toPrimitive"),Cn("toStringTag"),Cn("unscopables"),It(Math,"Math",!0),It(o.JSON,"JSON",!0);var Eo=$.Symbol,_o=Eo,Io=at("iterator"),To=!1;try{var Po=0,Do={next:function(){return{done:!!Po++}},return:function(){To=!0}};Do[Io]=function(){return this},Array.from(Do,(function(){throw 2}))}catch(t){}var Lo=!function(t,e){if(!e&&!To)return!1;var r=!1;try{var n={};n[Io]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));H({target:"Array",stat:!0,forced:Lo},{from:function(t){var e,r,n,o,i,a,u=Tt(t),c="function"==typeof this?this:Array,f=arguments.length,s=f>1?arguments[1]:void 0,l=void 0!==s,h=xt(u),v=0;if(l&&(s=B(s,f>2?arguments[2]:void 0,2)),null==h||c==Array&&st(h))for(r=new c(e=yt(u.length));e>v;v++)a=l?s(u[v],v):u[v],dn(r,v,a);else for(i=(o=h.call(u)).next,r=new c;!(n=i.call(o)).done;v++)a=l?kt(o,s,[n.value,v],!0):n.value,dn(r,v,a);return r.length=v,r}});var Mo=$.Array.from,Co=Mo,Fo=Or("slice"),Ro=jr("slice",{ACCESSORS:!0,0:0,1:2}),No=at("species"),zo=[].slice,Go=Math.max;H({target:"Array",proto:!0,forced:!Fo||!Ro},{slice:function(t,e){var r,n,o,i=F(this),a=yt(i.length),c=Ae(t,a),f=Ae(void 0===e?a:e,a);if(Pt(i)&&("function"!=typeof(r=i.constructor)||r!==Array&&!Pt(r.prototype)?u(r)&&null===(r=r[No])&&(r=void 0):r=void 0,r===Array||void 0===r))return zo.call(i,c,f);for(n=new(void 0===r?Array:r)(Go(f-c,0)),o=0;c<f;c++,o++)c in i&&dn(n,o,i[c]);return n.length=o,n}});var Uo=lr("Array").slice,Vo=Array.prototype,qo=function(t){var e=t.slice;return t===Vo||t instanceof Array&&e===Vo.slice?Uo:e},Wo=qo,Jo=Ce("Reflect","construct"),$o=i((function(){function t(){}return!(Jo((function(){}),[],t)instanceof t)})),Qo=!i((function(){Jo((function(){}))})),Bo=$o||Qo;H({target:"Reflect",stat:!0,forced:Bo,sham:Bo},{construct:function(t,e){Q(t),h(e);var r=arguments.length<3?t:Q(arguments[2]);if(Qo&&!$o)return Jo(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(Kr.apply(t,n))}var o=r.prototype,i=Ue(u(o)?o:Object.prototype),a=Function.apply.call(t,i,e);return u(a)?a:i}});var Ko=$.Reflect.construct,Yo=lr("Array").entries,Ho=Array.prototype,Xo={DOMTokenList:!0,NodeList:!0},Zo=function(t){var e=t.entries;return t===Ho||t instanceof Array&&e===Ho.entries||Xo.hasOwnProperty(wt(t))?Yo:e},ti=r((function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,o="function"==typeof Symbol?Symbol:{},i=o.iterator||"@@iterator",a=o.asyncIterator||"@@asyncIterator",u=o.toStringTag||"@@toStringTag";function c(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{c({},"")}catch(t){c=function(t,e,r){return t[e]=r}}function f(t,e,r,n){var o=e&&e.prototype instanceof d?e:d,i=Object.create(o.prototype),a=new _(n||[]);return i._invoke=function(t,e,r){var n=l;return function(o,i){if(n===v)throw new Error("Generator is already running");if(n===p){if("throw"===o)throw i;return T()}for(r.method=o,r.arg=i;;){var a=r.delegate;if(a){var u=j(a,r);if(u){if(u===y)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===l)throw n=p,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=v;var c=s(t,e,r);if("normal"===c.type){if(n=r.done?p:h,c.arg===y)continue;return{value:c.arg,done:r.done}}"throw"===c.type&&(n=p,r.method="throw",r.arg=c.arg)}}}(t,r,a),i}function s(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=f;var l="suspendedStart",h="suspendedYield",v="executing",p="completed",y={};function d(){}function g(){}function m(){}var b={};b[i]=function(){return this};var w=Object.getPrototypeOf,O=w&&w(w(I([])));O&&O!==r&&n.call(O,i)&&(b=O);var x=m.prototype=d.prototype=Object.create(b);function k(t){["next","throw","return"].forEach((function(e){c(t,e,(function(t){return this._invoke(e,t)}))}))}function S(t,e){function r(o,i,a,u){var c=s(t[o],t,i);if("throw"!==c.type){var f=c.arg,l=f.value;return l&&"object"==typeof l&&n.call(l,"__await")?e.resolve(l.__await).then((function(t){r("next",t,a,u)}),(function(t){r("throw",t,a,u)})):e.resolve(l).then((function(t){f.value=t,a(f)}),(function(t){return r("throw",t,a,u)}))}u(c.arg)}var o;this._invoke=function(t,n){function i(){return new e((function(e,o){r(t,n,e,o)}))}return o=o?o.then(i,i):i()}}function j(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,j(t,r),"throw"===r.method))return y;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return y}var o=s(n,t.iterator,r.arg);if("throw"===o.type)return r.method="throw",r.arg=o.arg,r.delegate=null,y;var i=o.arg;return i?i.done?(r[t.resultName]=i.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,y):i:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,y)}function A(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function E(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function _(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(A,this),this.reset(!0)}function I(t){if(t){var r=t[i];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var o=-1,a=function r(){for(;++o<t.length;)if(n.call(t,o))return r.value=t[o],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:T}}function T(){return{value:e,done:!0}}return g.prototype=x.constructor=m,m.constructor=g,g.displayName=c(m,u,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===g||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,c(t,u,"GeneratorFunction")),t.prototype=Object.create(x),t},t.awrap=function(t){return{__await:t}},k(S.prototype),S.prototype[a]=function(){return this},t.AsyncIterator=S,t.async=function(e,r,n,o,i){void 0===i&&(i=Promise);var a=new S(f(e,r,n,o),i);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},k(x),c(x,u,"Generator"),x[i]=function(){return this},x.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=I,_.prototype={constructor:_,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(E),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function o(n,o){return u.type="throw",u.arg=t,r.next=n,o&&(r.method="next",r.arg=e),!!o}for(var i=this.tryEntries.length-1;i>=0;--i){var a=this.tryEntries[i],u=a.completion;if("root"===a.tryLoc)return o("end");if(a.tryLoc<=this.prev){var c=n.call(a,"catchLoc"),f=n.call(a,"finallyLoc");if(c&&f){if(this.prev<a.catchLoc)return o(a.catchLoc,!0);if(this.prev<a.finallyLoc)return o(a.finallyLoc)}else if(c){if(this.prev<a.catchLoc)return o(a.catchLoc,!0)}else{if(!f)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return o(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var o=this.tryEntries[r];if(o.tryLoc<=this.prev&&n.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var i=o;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var a=i?i.completion:{};return a.type=t,a.arg=e,i?(this.method="next",this.next=i.finallyLoc,y):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),y},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),E(r),y}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;E(r)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:I(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),y}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),ei=Ln.f("iterator"),ri=ei;var ni=function(t,e,r){return e in t?en(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},oi=Ce("JSON","stringify"),ii=/[\uD800-\uDFFF]/g,ai=/^[\uD800-\uDBFF]$/,ui=/^[\uDC00-\uDFFF]$/,ci=function(t,e,r){var n=r.charAt(e-1),o=r.charAt(e+1);return ai.test(t)&&!ui.test(o)||ui.test(t)&&!ai.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},fi=i((function(){return'"\\udf06\\ud834"'!==oi("\udf06\ud834")||'"\\udead"'!==oi("\udead")}));oi&&H({target:"JSON",stat:!0,forced:fi},{stringify:function(t,e,r){var n=oi.apply(null,arguments);return"string"==typeof n?n.replace(ii,ci):n}}),$.JSON||($.JSON={stringify:JSON.stringify});var si=function(t,e,r){return $.JSON.stringify.apply(null,arguments)},li=lr("Array").values,hi=Array.prototype,vi={DOMTokenList:!0,NodeList:!0},pi=function(t){var e=t.values;return t===hi||t instanceof Array&&e===hi.values||vi.hasOwnProperty(wt(t))?li:e},yi=[],di=yi.sort,gi=i((function(){yi.sort(void 0)})),mi=i((function(){yi.sort(null)})),bi=zr("sort");H({target:"Array",proto:!0,forced:gi||!mi||!bi},{sort:function(t){return void 0===t?di.call(Tt(this)):di.call(Tt(this),Q(t))}});var wi=lr("Array").sort,Oi=Array.prototype,xi=function(t){var e=t.sort;return t===Oi||t instanceof Array&&e===Oi.sort?wi:e},ki=i((function(){De(1)}));H({target:"Object",stat:!0,forced:ki},{keys:function(t){return De(Tt(t))}});var Si=$.Object.keys,ji=lr("Array").keys,Ai=Array.prototype,Ei={DOMTokenList:!0,NodeList:!0},_i=function(t){var e=t.keys;return t===Ai||t instanceof Array&&e===Ai.keys||Ei.hasOwnProperty(wt(t))?ji:e};H({target:"Array",stat:!0},{isArray:Pt});var Ii=$.Array.isArray,Ti=Ii;var Pi=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var Di=function(t){if(Ti(t))return Pi(t)},Li=Mo,Mi=at("iterator"),Ci=function(t){var e=Object(t);return void 0!==e[Mi]||"@@iterator"in e||ut.hasOwnProperty(wt(e))};Cn("asyncDispose"),Cn("dispose"),Cn("observable"),Cn("patternMatch"),Cn("replaceAll");var Fi=Eo;var Ri=function(t){if(void 0!==Fi&&Ci(Object(t)))return Li(t)},Ni=qo;var zi=function(t,e){var r;if(t){if("string"==typeof t)return Pi(t,e);var n=Ni(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Li(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Pi(t,e):void 0}};var Gi=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Ui=function(t){return Di(t)||Ri(t)||zi(t)||Gi()},Vi=lr("Array").concat,qi=Array.prototype,Wi=function(t){var e=t.concat;return t===qi||t instanceof Array&&e===qi.concat?Vi:e},Ji=Object.assign,$i=Object.defineProperty,Qi=!Ji||i((function(){if(a&&1!==Ji({b:1},Ji($i({},"a",{enumerable:!0,get:function(){$i(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Ji({},t)[r]||De(Ji({},e)).join("")!=n}))?function(t,e){for(var r=Tt(t),n=arguments.length,o=1,i=pn.f,u=T.f;n>o;)for(var c,f=M(arguments[o++]),s=i?De(f).concat(i(f)):De(f),l=s.length,h=0;l>h;)c=s[h++],a&&!u.call(f,c)||(r[c]=f[c]);return r}:Ji;H({target:"Object",stat:!0,forced:Object.assign!==Qi},{assign:Qi});var Bi=$.Object.assign,Ki=Ft.some,Yi=zr("some"),Hi=jr("some");H({target:"Array",proto:!0,forced:!Yi||!Hi},{some:function(t){return Ki(this,t,arguments.length>1?arguments[1]:void 0)}});var Xi=lr("Array").some,Zi=Array.prototype,ta=function(t){var e=t.some;return t===Zi||t instanceof Array&&e===Zi.some?Xi:e},ea=ei,ra=r((function(t){function e(r){return t.exports=e="function"==typeof Fi&&"symbol"==typeof ea?function(t){return typeof t}:function(t){return t&&"function"==typeof Fi&&t.constructor===Fi&&t!==Fi.prototype?"symbol":typeof t},e(r)}t.exports=e})),na=at("species"),oa=y.f,ia=E.fastKey,aa=Xt.set,ua=Xt.getterFor,ca={getConstructor:function(t,e,r,n){var o=t((function(t,i){jt(t,o,e),aa(t,{type:e,index:Ue(null),first:void 0,last:void 0,size:0}),a||(t.size=0),null!=i&&St(i,t[n],t,r)})),i=ua(e),u=function(t,e,r){var n,o,u=i(t),f=c(t,e);return f?f.value=r:(u.last=f={index:o=ia(e,!0),key:e,value:r,previous:n=u.last,next:void 0,removed:!1},u.first||(u.first=f),n&&(n.next=f),a?u.size++:t.size++,"F"!==o&&(u.index[o]=f)),t},c=function(t,e){var r,n=i(t),o=ia(e);if("F"!==o)return n.index[o];for(r=n.first;r;r=r.next)if(r.key==e)return r};return b(o.prototype,{clear:function(){for(var t=i(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,a?t.size=0:this.size=0},delete:function(t){var e=this,r=i(e),n=c(e,t);if(n){var o=n.next,u=n.previous;delete r.index[n.index],n.removed=!0,u&&(u.next=o),o&&(o.previous=u),r.first==n&&(r.first=o),r.last==n&&(r.last=u),a?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=i(this),n=B(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!c(this,t)}}),b(o.prototype,r?{get:function(t){var e=c(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),a&&oa(o.prototype,"size",{get:function(){return i(this).size}}),o},setStrong:function(t,e,r){var n=e+" Iterator",o=ua(e),i=ua(n);Xe(t,e,(function(t,e){aa(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=i(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=Ce(t),r=y.f;a&&e&&!e[na]&&r(e,na,{configurable:!0,get:function(){return this}})}(e)}},fa=(ne("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ca),$.Map),sa=Ii;var la=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};H({target:"Object",stat:!0,sham:!a},{create:Ue});var ha=$.Object,va=function(t,e){return ha.create(t,e)},pa=va;H({target:"Object",stat:!0},{setPrototypeOf:We});var ya=$.Object.setPrototypeOf,da=r((function(t){function e(r,n){return t.exports=e=ya||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var ga=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=pa(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&da(t,e)};var ma=function(t,e){return!e||"object"!==ra(e)&&"function"!=typeof e?la(t):e},ba=i((function(){we(1)}));H({target:"Object",stat:!0,forced:ba,sham:!ge},{getPrototypeOf:function(t){return we(Tt(t))}});var wa=$.Object.getPrototypeOf,Oa=r((function(t){function e(r){return t.exports=e=ya?wa:function(t){return t.__proto__||wa(t)},e(r)}t.exports=e})),xa="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),ka=new Uint8Array(16);function Sa(){if(!xa)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return xa(ka)}var ja=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function Aa(t){return"string"==typeof t&&ja.test(t)}for(var Ea=[],_a=0;_a<256;++_a)Ea.push((_a+256).toString(16).substr(1));function Ia(t,e,r){var n=(t=t||{}).random||(t.rng||Sa)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var o=0;o<16;++o)e[r+o]=n[o];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(Ea[t[e+0]]+Ea[t[e+1]]+Ea[t[e+2]]+Ea[t[e+3]]+"-"+Ea[t[e+4]]+Ea[t[e+5]]+"-"+Ea[t[e+6]]+Ea[t[e+7]]+"-"+Ea[t[e+8]]+Ea[t[e+9]]+"-"+Ea[t[e+10]]+Ea[t[e+11]]+Ea[t[e+12]]+Ea[t[e+13]]+Ea[t[e+14]]+Ea[t[e+15]]).toLowerCase();if(!Aa(r))throw TypeError("Stringified UUID is invalid");return r}(n)}var Ta,Pa=va,Da="\t\n\v\f\r                　\u2028\u2029\ufeff",La="["+Da+"]",Ma=RegExp("^"+La+La+"*"),Ca=RegExp(La+La+"*$"),Fa=function(t){return function(e){var r=String(C(e));return 1&t&&(r=r.replace(Ma,"")),2&t&&(r=r.replace(Ca,"")),r}},Ra={start:Fa(1),end:Fa(2),trim:Fa(3)},Na=Ra.trim;H({target:"String",proto:!0,forced:(Ta="trim",i((function(){return!!Da[Ta]()||"​᠎"!="​᠎"[Ta]()||Da[Ta].name!==Ta})))},{trim:function(){return Na(this)}});lr("String").trim;var za=Ra.trim,Ga=o.parseInt,Ua=/^[+-]?0[Xx]/,Va=8!==Ga(Da+"08")||22!==Ga(Da+"0x16")?function(t,e){var r=za(String(t));return Ga(r,e>>>0||(Ua.test(r)?16:10))}:Ga;H({global:!0,forced:parseInt!=Va},{parseInt:Va});var qa=T.f,Wa=function(t){return function(e){for(var r,n=F(e),o=De(n),i=o.length,u=0,c=[];i>u;)r=o[u++],a&&!qa.call(n,r)||c.push(t?[r,n[r]]:n[r]);return c}},Ja={entries:Wa(!0),values:Wa(!1)}.values;H({target:"Object",stat:!0},{values:function(t){return Ja(t)}});$.Object.values;var $a=_e.indexOf,Qa=[].indexOf,Ba=!!Qa&&1/[1].indexOf(1,-0)<0,Ka=zr("indexOf"),Ya=jr("indexOf",{ACCESSORS:!0,1:0});H({target:"Array",proto:!0,forced:Ba||!Ka||!Ya},{indexOf:function(t){return Ba?Qa.apply(this,arguments)||0:$a(this,t,arguments.length>1?arguments[1]:void 0)}});lr("Array").indexOf;var Ha=function(t){if(Ti(t))return t};var Xa=function(t,e){if(void 0!==Fi&&Ci(Object(t))){var r=[],n=!0,o=!1,i=void 0;try{for(var a,u=bo(t);!(n=(a=u.next()).done)&&(r.push(a.value),!e||r.length!==e);n=!0);}catch(t){o=!0,i=t}finally{try{n||null==u.return||u.return()}finally{if(o)throw i}}return r}};var Za=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var tu=function(t,e){return Ha(t)||Xa(t,e)||zi(t,e)||Za()};H({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});$.Date.now;H({target:"Reflect",stat:!0},{ownKeys:yn});var eu=$.Reflect.ownKeys;function ru(t,e){var r;if(void 0===_o||null==wo(t)){if(sa(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return nu(t,e);var n=Wo(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Co(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return nu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=bo(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function nu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}
/**
	 * vis-util
	 * https://github.com/visjs/vis-util
	 *
	 * utilitie collection for visjs
	 *
	 * @version 4.3.4
	 * @date    2020-08-01T15:11:53.524Z
	 *
	 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
	 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
	 *
	 * @license
	 * vis.js is dual licensed under both
	 *
	 *   1. The Apache 2.0 License
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 *   and
	 *
	 *   2. The MIT License
	 *      http://opensource.org/licenses/MIT
	 *
	 * vis.js may be distributed under either license.
	 */var ou=_o("DELETE");function iu(){var t=au.apply(void 0,arguments);return cu(t),t}function au(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return au.apply(void 0,Wi(n=[iu(e[0],e[1])]).call(n,Ui(Wo(e).call(e,2))));var o,i=e[0],a=e[1],u=ru(eu(a));try{for(u.s();!(o=u.n()).done;){var c=o.value;Object.prototype.propertyIsEnumerable.call(a,c)&&(a[c]===ou?delete i[c]:null===i[c]||null===a[c]||"object"!==ra(i[c])||"object"!==ra(a[c])||sa(i[c])||sa(a[c])?i[c]=uu(a[c]):i[c]=au(i[c],a[c]))}}catch(t){u.e(t)}finally{u.f()}return i}function uu(t){return sa(t)?Pr(t).call(t,(function(t){return uu(t)})):"object"===ra(t)&&null!==t?au({},t):t}function cu(t){for(var e=0,r=Si(t);e<r.length;e++){var n=r[e];t[n]===ou?delete t[n]:"object"===ra(t[n])&&null!==t[n]&&cu(t[n])}}function fu(t){return"string"==typeof t||"number"==typeof t}var su=Or("splice"),lu=jr("splice",{ACCESSORS:!0,0:0,1:2}),hu=Math.max,vu=Math.min,pu=9007199254740991,yu="Maximum allowed length exceeded";H({target:"Array",proto:!0,forced:!su||!lu},{splice:function(t,e){var r,n,o,i,a,u,c=Tt(this),f=yt(c.length),s=Ae(t,f),l=arguments.length;if(0===l?r=n=0:1===l?(r=0,n=f-s):(r=l-2,n=vu(hu(vt(e),0),f-s)),f+r-n>pu)throw TypeError(yu);for(o=Lt(c,n),i=0;i<n;i++)(a=s+i)in c&&dn(o,i,c[a]);if(o.length=n,r<n){for(i=s;i<f-n;i++)u=i+r,(a=i+n)in c?c[u]=c[a]:delete c[u];for(i=f;i>f-n+r;i--)delete c[i-1]}else if(r>n)for(i=f-n;i>s;i--)u=i+r-1,(a=i+n-1)in c?c[u]=c[a]:delete c[u];for(i=0;i<r;i++)c[i+s]=arguments[i+2];return c.length=f-n+r,o}});var du=lr("Array").splice,gu=Array.prototype,mu=function(t){var e=t.splice;return t===gu||t instanceof Array&&e===gu.splice?du:e},bu=[].slice,wu=/MSIE .\./.test(yr),Ou=function(t){return function(e,r){var n=arguments.length>2,o=n?bu.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,o)}:e,r)}};H({global:!0,bind:!0,forced:wu},{setTimeout:Ou(o.setTimeout),setInterval:Ou(o.setInterval)});var xu,ku,Su,ju,Au=$.setTimeout,Eu=function(){function t(e){Zr(this,t),xu.set(this,[]),ku.set(this,null),Su.set(this,null),this.delay=null,this.max=1/0,this.setOptions(e)}return on(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),an(this,Su)){for(var t=an(this,Su).object,e=an(this,Su).methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}un(this,Su,null)}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?an(this,xu).push({fn:t}):an(this,xu).push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;an(this,xu).length>this.max&&this.flush(),null!=an(this,ku)&&(clearTimeout(an(this,ku)),un(this,ku,null)),this.queue.length>0&&"number"==typeof this.delay&&un(this,ku,Au((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;jn(t=mu(e=an(this,xu)).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(r&&r.replace)for(var i=0;i<r.replace.length;i++){var a=r.replace[i];o.push({name:a,original:e[a]}),n.replace(e,a)}return un(n,Su,{object:e,methods:o}),n}}]),t}();xu=new ar,ku=new ar,Su=new ar;var _u=function(){function t(){Zr(this,t),ju.set(this,{"*":[],add:[],remove:[],update:[]}),this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return on(t,[{key:"_trigger",value:function(t,e,r){var n,o;if("*"===t)throw new Error("Cannot trigger event *");jn(n=Wi(o=[]).call(o,Ui(an(this,ju)[t]),Ui(an(this,ju)["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&an(this,ju)[t].push(e)}},{key:"off",value:function(t,e){var r;an(this,ju)[t]=Rr(r=an(this,ju)[t]).call(r,(function(t){return t!==e}))}}]),t}();ju=new ar;ne("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ca);var Iu,Tu=$.Set;function Pu(t,e){var r;if(void 0===_o||null==wo(t)){if(sa(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Du(t,e);var n=Wo(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Co(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Du(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=bo(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Du(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var Lu,Mu,Cu,Fu,Ru=function(){function t(e){Zr(this,t),Iu.set(this,void 0),un(this,Iu,e)}return on(t,[{key:(Iu=new ar,ri),value:ti.mark((function t(){var e,r,n,o,i;return ti.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Pu(an(this,Iu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=tu(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:ti.mark((function t(){var e,r,n,o,i;return ti.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Pu(an(this,Iu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=tu(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:ti.mark((function t(){var e,r,n,o;return ti.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Pu(an(this,Iu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=tu(r.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:ti.mark((function t(){var e,r,n,o;return ti.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Pu(an(this,Iu)),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=tu(r.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Pr(t=Ui(an(this,Iu))).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Pr(t=Ui(an(this,Iu))).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Ui(an(this,Iu))}},{key:"toObjectMap",value:function(){var t,e=Pa(null),r=Pu(an(this,Iu));try{for(r.s();!(t=r.n()).done;){var n=tu(t.value,2),o=n[0],i=n[1];e[o]=i}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new fa(an(this,Iu))}},{key:"toIdSet",value:function(){return new Tu(this.toIdArray())}},{key:"toItemSet",value:function(){return new Tu(this.toItemArray())}},{key:"cache",value:function(){return new t(Ui(an(this,Iu)))}},{key:"distinct",value:function(t){var e,r=new Tu,n=Pu(an(this,Iu));try{for(n.s();!(e=n.n()).done;){var o=tu(e.value,2),i=o[0],a=o[1];r.add(t(a,i))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=an(this,Iu);return new t(ni({},ri,ti.mark((function t(){var n,o,i,a,u;return ti.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Pu(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=10;break}if(i=tu(o.value,2),a=i[0],u=i[1],!e(u,a)){t.next=8;break}return t.next=8,[a,u];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=Pu(an(this,Iu));try{for(r.s();!(e=r.n()).done;){var n=tu(e.value,2),o=n[0];t(n[1],o)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=an(this,Iu);return new t(ni({},ri,ti.mark((function t(){var n,o,i,a,u;return ti.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Pu(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=9;break}return i=tu(o.value,2),a=i[0],u=i[1],t.next=7,[a,e(u,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=bo(an(this,Iu)),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=tu(r.value,2),a=i[0],u=i[1],c=t(u,a);c>o&&(o=c,n=u)}return n}},{key:"min",value:function(t){var e=bo(an(this,Iu)),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=tu(r.value,2),a=i[0],u=i[1],c=t(u,a);c<o&&(o=c,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=Pu(an(this,Iu));try{for(n.s();!(r=n.n()).done;){var o=tu(r.value,2),i=o[0];e=t(e,o[1],i)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(ni({},ri,(function(){var t;return bo(xi(t=Ui(an(r,Iu))).call(t,(function(t,r){var n=tu(t,2),o=n[0],i=n[1],a=tu(r,2),u=a[0],c=a[1];return e(i,c,o,u)})))})))}}]),t}();function Nu(t,e){var r=Si(t);if(ho){var n=ho(t);e&&(n=Rr(n).call(n,(function(e){return _n(t,e).enumerable}))),r.push.apply(r,n)}return r}function zu(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)jn(r=Nu(Object(n),!0)).call(r,(function(e){ni(t,e,n[e])}));else if(gn)ln(t,gn(n));else{var o;jn(o=Nu(Object(n))).call(o,(function(e){sn(t,e,_n(n,e))}))}}return t}function Gu(t,e){var r;if(void 0===_o||null==wo(t)){if(sa(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Uu(t,e);var n=Wo(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Co(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Uu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=bo(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Uu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Vu(t){var e=function(){if("undefined"==typeof Reflect||!Ko)return!1;if(Ko.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Ko(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Oa(t);if(e){var o=Oa(this).constructor;r=Ko(n,arguments,o)}else r=n.apply(this,arguments);return ma(this,r)}}var qu,Wu,Ju,$u,Qu=function(t){ga(r,t);var e=Vu(r);function r(t,n){var o;return Zr(this,r),o=e.call(this),Lu.set(la(o),void 0),Mu.set(la(o),void 0),Cu.set(la(o),void 0),Fu.set(la(o),null),t&&!sa(t)&&(n=t,t=[]),un(la(o),Lu,n||{}),un(la(o),Mu,new fa),o.length=0,un(la(o),Cu,an(la(o),Lu).fieldId||"id"),t&&t.length&&o.add(t),o.setOptions(n),o}return on(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?an(this,Fu)&&(an(this,Fu).destroy(),un(this,Fu,null)):(an(this,Fu)||un(this,Fu,Eu.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===ra(t.queue)&&an(this,Fu).setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,o=[];if(sa(t)){var i=Pr(t).call(t,(function(t){return t[an(n,Cu)]}));if(ta(i).call(i,(function(t){return an(n,Mu).has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),o.push(r)}else{if(!t||"object"!==ra(t))throw new Error("Unknown dataType");r=this._addItem(t),o.push(r)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var r=this,n=[],o=[],i=[],a=[],u=an(this,Cu),c=function(t){var e=t[u];if(null!=e&&an(r,Mu).has(e)){var c=t,f=Bi({},an(r,Mu).get(e)),s=r._updateItem(c);o.push(s),a.push(c),i.push(f)}else{var l=r._addItem(t);n.push(l)}};if(sa(t))for(var f=0,s=t.length;f<s;f++)t[f]&&"object"===ra(t[f])?c(t[f]):console.warn("Ignoring input item, which is not an object at index "+f);else{if(!t||"object"!==ra(t))throw new Error("Unknown dataType");c(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var l={items:o,oldData:i,data:a};this._trigger("update",l,e)}return Wi(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var r,n=this;sa(t)||(t=[t]);var o=Pr(r=Pr(t).call(t,(function(t){var e=an(n,Mu).get(t[an(n,Cu)]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,o=e[an(n,Cu)],i=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];return iu.apply(void 0,Wi(e=[{},t]).call(e,n))}(e,r);return an(n,Mu).set(o,i),{id:o,oldData:e,updatedData:i}}));if(o.length){var i={items:Pr(o).call(o,(function(t){return t.id})),oldData:Pr(o).call(o,(function(t){return t.oldData})),data:Pr(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",i,e),i.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,o=void 0;fu(t)?(r=t,o=e):sa(t)?(n=t,o=e):o=t;var i=o&&"Object"===o.returnType?"Object":"Array",a=o&&Rr(o),u=[],c=void 0,f=void 0,s=void 0;if(null!=r)(c=an(this,Mu).get(r))&&a&&!a(c)&&(c=void 0);else if(null!=n)for(var l=0,h=n.length;l<h;l++)null==(c=an(this,Mu).get(n[l]))||a&&!a(c)||u.push(c);else for(var v,p=0,y=(f=Ui(_i(v=an(this,Mu)).call(v))).length;p<y;p++)s=f[p],null==(c=an(this,Mu).get(s))||a&&!a(c)||u.push(c);if(o&&o.order&&null==r&&this._sort(u,o.order),o&&o.fields){var d=o.fields;if(null!=r&&null!=c)c=this._filterFields(c,d);else for(var g=0,m=u.length;g<m;g++)u[g]=this._filterFields(u[g],d)}if("Object"==i){for(var b={},w=0,O=u.length;w<O;w++){var x=u[w];b[x[an(this,Cu)]]=x}return b}return null!=r?null!=c?c:null:u}},{key:"getIds",value:function(t){var e=an(this,Mu),r=t&&Rr(t),n=t&&t.order,o=Ui(_i(e).call(e)),i=[];if(r)if(n){for(var a=[],u=0,c=o.length;u<c;u++){var f=o[u],s=an(this,Mu).get(f);null!=s&&r(s)&&a.push(s)}this._sort(a,n);for(var l=0,h=a.length;l<h;l++)i.push(a[l][an(this,Cu)])}else for(var v=0,p=o.length;v<p;v++){var y=o[v],d=an(this,Mu).get(y);null!=d&&r(d)&&i.push(d[an(this,Cu)])}else if(n){for(var g=[],m=0,b=o.length;m<b;m++){var w=o[m];g.push(e.get(w))}this._sort(g,n);for(var O=0,x=g.length;O<x;O++)i.push(g[O][an(this,Cu)])}else for(var k=0,S=o.length;k<S;k++){var j=o[k],A=e.get(j);null!=A&&i.push(A[an(this,Cu)])}return i}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Rr(e),n=an(this,Mu),o=Ui(_i(n).call(n));if(e&&e.order)for(var i=this.get(e),a=0,u=i.length;a<u;a++){var c=i[a];t(c,c[an(this,Cu)])}else for(var f=0,s=o.length;f<s;f++){var l=o[f],h=an(this,Mu).get(l);null==h||r&&!r(h)||t(h,l)}}},{key:"map",value:function(t,e){for(var r=e&&Rr(e),n=[],o=an(this,Mu),i=Ui(_i(o).call(o)),a=0,u=i.length;a<u;a++){var c=i[a],f=an(this,Mu).get(c);null==f||r&&!r(f)||n.push(t(f,c))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?Jr(r=sa(e)?e:Si(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;xi(t).call(t,(function(t,e){var n=t[r],o=e[r];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");xi(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],o=sa(t)?t:[t],i=0,a=o.length;i<a;i++){var u=this._remove(o[i]);if(u){var c=u[an(this,Cu)];null!=c&&(r.push(c),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(fu(t)?e=t:t&&"object"===ra(t)&&(e=t[an(this,Cu)]),null!=e&&an(this,Mu).has(e)){var r=an(this,Mu).get(e)||null;return an(this,Mu).delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Ui(_i(e=an(this,Mu)).call(e)),n=[],o=0,i=r.length;o<i;o++)n.push(an(this,Mu).get(r[o]));return an(this,Mu).clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,o=null,i=Gu(pi(e=an(this,Mu)).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u>o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,o=null,i=Gu(pi(e=an(this,Mu)).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u<o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"distinct",value:function(t){for(var e=an(this,Mu),r=Ui(_i(e).call(e)),n=[],o=0,i=0,a=r.length;i<a;i++){for(var u=r[i],c=e.get(u)[t],f=!1,s=0;s<o;s++)if(n[s]==c){f=!0;break}f||void 0===c||(n[o]=c,o++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=Ia()),t}(t,an(this,Cu)),r=e[an(this,Cu)];if(an(this,Mu).has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return an(this,Mu).set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[an(this,Cu)];if(null==e)throw new Error("Cannot update item: item has no id (item: "+si(t)+")");var r=an(this,Mu).get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return an(this,Mu).set(e,zu(zu({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=an(this,Mu);return new Ru(ni({},ri,ti.mark((function r(){var n,o,i,a;return ti.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Gu(t),r.prev=1,n.s();case 3:if((o=n.n()).done){r.next=11;break}if(i=o.value,null==(a=e.get(i))){r.next=9;break}return r.next=9,[i,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new Ru(ni({},ri,Xr(r=Zo(an(this,Mu))).call(r,an(this,Mu))))}}]),r}(_u);function Bu(t,e){var r;if(void 0===_o||null==wo(t)){if(sa(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Ku(t,e);var n=Wo(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Co(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ku(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=bo(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Ku(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Yu(t){var e=function(){if("undefined"==typeof Reflect||!Ko)return!1;if(Ko.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Ko(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Oa(t);if(e){var o=Oa(this).constructor;r=Ko(n,arguments,o)}else r=n.apply(this,arguments);return ma(this,r)}}Lu=new ar,Mu=new ar,Cu=new ar,Fu=new ar;var Hu=function(t){ga(r,t);var e=Yu(r);function r(t,n){var o,i;return Zr(this,r),(i=e.call(this)).length=0,qu.set(la(i),void 0),Wu.set(la(i),void 0),Ju.set(la(i),new Tu),$u.set(la(i),void 0),un(la(i),$u,n||{}),un(la(i),qu,Xr(o=i._onEvent).call(o,la(i))),i.setData(t),i}return on(r,[{key:"setData",value:function(t){if(an(this,Wu)){an(this,Wu).off&&an(this,Wu).off("*",an(this,qu));var e=an(this,Wu).getIds({filter:Rr(an(this,$u))}),r=an(this,Wu).get(e);an(this,Ju).clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){un(this,Wu,t);for(var n=an(this,Wu).getIds({filter:Rr(an(this,$u))}),o=0,i=n.length;o<i;o++){var a=n[o];an(this,Ju).add(a)}this.length=n.length,this._trigger("add",{items:n})}else un(this,Wu,new Qu);an(this,Wu).on&&an(this,Wu).on("*",an(this,qu))}},{key:"refresh",value:function(){for(var t=an(this,Wu).getIds({filter:Rr(an(this,$u))}),e=Ui(an(this,Ju)),r={},n=[],o=[],i=[],a=0,u=t.length;a<u;a++){var c=t[a];r[c]=!0,an(this,Ju).has(c)||(n.push(c),an(this,Ju).add(c))}for(var f=0,s=e.length;f<s;f++){var l=e[f],h=an(this,Wu).get(l);null==h?console.error("If you see this, report it please."):r[l]||(o.push(l),i.push(h),an(this,Ju).delete(l))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:i})}},{key:"get",value:function(t,e){if(null==an(this,Wu))return null;var r,n=null;fu(t)||sa(t)?(n=t,r=e):r=t;var o=Bi({},an(this,$u),r),i=Rr(an(this,$u)),a=r&&Rr(r);return i&&a&&(o.filter=function(t){return i(t)&&a(t)}),null==n?an(this,Wu).get(o):an(this,Wu).get(n,o)}},{key:"getIds",value:function(t){if(an(this,Wu).length){var e,r=Rr(an(this,$u)),n=null!=t?Rr(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,an(this,Wu).getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(an(this,Wu)){var r,n,o=Rr(an(this,$u)),i=e&&Rr(e);n=i?o?function(t){return o(t)&&i(t)}:i:o,jn(r=an(this,Wu)).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(an(this,Wu)){var r,n,o=Rr(an(this,$u)),i=e&&Rr(e);return n=i?o?function(t){return o(t)&&i(t)}:i:o,Pr(r=an(this,Wu)).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return an(this,Wu).getDataSet()}},{key:"stream",value:function(t){var e;return an(this,Wu).stream(t||ni({},ri,Xr(e=_i(an(this,Ju))).call(e,an(this,Ju))))}},{key:"dispose",value:function(){var t;(null===(t=an(this,Wu))||void 0===t?void 0:t.off)&&an(this,Wu).off("*",an(this,qu));var e,n="This data view has already been disposed of.",o={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},i=Bu(eu(r.prototype));try{for(i.s();!(e=i.n()).done;){var a=e.value;sn(this,a,o)}}catch(t){i.e(t)}finally{i.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&an(this,Wu)){var n=e.items,o=[],i=[],a=[],u=[],c=[],f=[];switch(t){case"add":for(var s=0,l=n.length;s<l;s++){var h=n[s];this.get(h)&&(an(this,Ju).add(h),o.push(h))}break;case"update":for(var v=0,p=n.length;v<p;v++){var y=n[v];this.get(y)?an(this,Ju).has(y)?(i.push(y),c.push(e.data[v]),u.push(e.oldData[v])):(an(this,Ju).add(y),o.push(y)):an(this,Ju).has(y)&&(an(this,Ju).delete(y),a.push(y),f.push(e.oldData[v]))}break;case"remove":for(var d=0,g=n.length;d<g;d++){var m=n[d];an(this,Ju).has(m)&&(an(this,Ju).delete(m),a.push(m),f.push(e.oldData[d]))}}this.length+=o.length-a.length,o.length&&this._trigger("add",{items:o},r),i.length&&this._trigger("update",{items:i,oldData:u,data:c},r),a.length&&this._trigger("remove",{items:a,oldData:f},r)}}}]),r}(_u);qu=new ar,Wu=new ar,Ju=new ar,$u=new ar,t.DELETE=ou,t.DataSet=Qu,t.DataStream=Ru,t.DataView=Hu,t.Queue=Eu,t.createNewDataPipeFrom=function(t){return new fn(t)},Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-data.min.js.map
